/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, toNullable, Boolean_$type, fromEnum, markType, getInstanceType } from "igniteui-angular-core";
import { ST_AnimationChartBuildType } from "./ST_AnimationChartBuildType";
import { ST_OnOff } from "./ST_OnOff";
/**
 * @hidden
 */
export let CT_AnimationChartBuildProperties = /*@__PURE__*/ (() => {
    class CT_AnimationChartBuildProperties extends Base {
        constructor() {
            super();
            this.b = null;
            this.e = toNullable(Boolean_$type, null);
        }
        get a() {
            return this.b;
        }
        set a(a) {
            this.b = a;
        }
        get d() {
            return this.e;
        }
        set d(a) {
            this.e = a;
        }
        static g(a, b, c) {
            b = null;
            c = toNullable(Boolean_$type, null);
            for (let d of fromEnum(a.ab.u)) {
                switch (d.a.e(a.d)) {
                    case "bld":
                        b = ST_AnimationChartBuildType.a(d.d);
                        break;
                    case "animBg":
                        c = toNullable(Boolean_$type, ST_OnOff.e(d.d));
                        break;
                    default: break;
                }
            }
            ;
            return {
                p1: b,
                p2: c
            };
        }
        static h(a, b, c = toNullable(Boolean_$type, null), d = null) {
            a.ad.p(b, "a");
            let e = null;
            let f = null;
            if (c.hasValue) {
                f = "animBg";
                e = ST_OnOff.g(c.value);
                a.ad.h(f, e);
            }
            if (d != null) {
                f = "bld";
                e = d.g();
                a.ad.h(f, e);
            }
            ;
        }
        toString() {
            let a = getInstanceType(this);
            return a != null ? a.typeName : super.toString();
        }
    }
    CT_AnimationChartBuildProperties.$t = markType(CT_AnimationChartBuildProperties, 'CT_AnimationChartBuildProperties');
    return CT_AnimationChartBuildProperties;
})();
