/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which define the type of a category axis.
 */
export var CategoryType = /*@__PURE__*/ (function (CategoryType) {
    /**
     * Scale is determined automatically.
     */
    CategoryType[CategoryType["AutomaticScale"] = -4105] = "AutomaticScale";
    /**
     * A category [[Axis]].
     */
    CategoryType[CategoryType["CategoryScale"] = 2] = "CategoryScale";
    /**
     * A date/time [[Axis]].
     */
    CategoryType[CategoryType["TimeScale"] = 3] = "TimeScale";
    return CategoryType;
})({});
/**
 * @hidden
 */
export let CategoryType_$type = markEnum('CategoryType', 'AutomaticScale,-4105|CategoryScale,2|TimeScale,3');
