/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine whether <see cref="DataBarConditionalFormat">data bars</see> are filled with a solid color or
 * with a gradient.
 */
export var DataBarFillType = /*@__PURE__*/ (function (DataBarFillType) {
    /**
     * Data bars are filled with a solid color.
     */
    DataBarFillType[DataBarFillType["SolidColor"] = 0] = "SolidColor";
    /**
     * Data bars are filled with a linear gradient.
     */
    DataBarFillType[DataBarFillType["Gradient"] = 1] = "Gradient";
    return DataBarFillType;
})({});
/**
 * @hidden
 */
export let DataBarFillType_$type = markEnum('DataBarFillType', 'SolidColor,0|Gradient,1');
