/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constans which identify whether a [[RankConditionalFormat]] evaluates
 * to true for the top or bottom ranked values across the associated range.
 */
export var FormatConditionTopBottom = /*@__PURE__*/ (function (FormatConditionTopBottom) {
    /**
     * The cell value must fall within the bottom ranking of values for the associated range.
     */
    FormatConditionTopBottom[FormatConditionTopBottom["Bottom"] = 0] = "Bottom";
    /**
     * The cell value must fall within the top ranking of values for the associated range.
     */
    FormatConditionTopBottom[FormatConditionTopBottom["Top"] = 1] = "Top";
    return FormatConditionTopBottom;
})({});
/**
 * @hidden
 */
export let FormatConditionTopBottom_$type = markEnum('FormatConditionTopBottom', 'Bottom,0|Top,1');
