/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SystemException, markType } from "igniteui-angular-core";
/**
 * Represents an error in which a keyed collection was accessed with a key which does not exist in the collection.
 */
export let KeyNotFoundException = /*@__PURE__*/ (() => {
    class KeyNotFoundException extends SystemException {
        constructor(message, innerException) {
            super(2, message, innerException);
            message = (message !== void 0 ? message : null);
            innerException = (innerException !== void 0 ? innerException : null);
        }
    }
    KeyNotFoundException.$t = markType(KeyNotFoundException, 'KeyNotFoundException', SystemException.$);
    return KeyNotFoundException;
})();
