/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the manner in which a picture is displayed.
 */
export var PictureType = /*@__PURE__*/ (function (PictureType) {
    /**
     * The picture is stretched to fill it's containing element.
     */
    PictureType[PictureType["Stretch"] = 1] = "Stretch";
    /**
     * The picture is stacked or tiled to fill it's containing element.
     */
    PictureType[PictureType["Stack"] = 2] = "Stack";
    /**
     * The picture is scaled to fill it's containing element.
     */
    PictureType[PictureType["Scale"] = 3] = "Scale";
    return PictureType;
})({});
/**
 * @hidden
 */
export let PictureType_$type = markEnum('PictureType', 'Stretch,1|Stack,2|Scale,3');
