/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ValueType, toNullable, Number_$type, markStruct } from "igniteui-angular-core";
import { DocCoreUtils } from "./DocCoreUtils";
import { CultureInfo } from "igniteui-angular-core";
import { parseInt32_2, tryParseInt32_2 } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ST_TextMargin = /*@__PURE__*/ (() => {
    class ST_TextMargin extends ValueType {
        constructor(a, ..._rest) {
            super();
            this.d = 0;
            a = (a == void 0) ? 0 : a;
            switch (a) {
                case 0: break;
                case 1:
                    {
                        let c = _rest[0];
                        DocCoreUtils.aw(ST_TextMargin.$, c, "value", 0, 51206400);
                        this.d = c;
                    }
                    break;
            }
        }
        static c(a) {
            return ST_TextMargin.a(parseInt32_2(a, 7, CultureInfo.invariantCulture));
        }
        static i(a) {
            let b;
            if (((() => { let c = tryParseInt32_2(a, 7, CultureInfo.invariantCulture, b); b = c.p3; return c.ret; })())) {
                return toNullable(ST_TextMargin.$, ST_TextMargin.a(b));
            }
            return toNullable(ST_TextMargin.$, null);
        }
        toString() {
            return this.d.toString();
        }
        static e(a) {
            return a.d;
        }
        static g(a) {
            if (!a.hasValue) {
                return toNullable(Number_$type, null);
            }
            return toNullable(Number_$type, ST_TextMargin.e(a.value));
        }
        static a(a) {
            return new ST_TextMargin(1, a);
        }
        static h(a) {
            if (!a.hasValue) {
                return toNullable(ST_TextMargin.$, null);
            }
            return toNullable(ST_TextMargin.$, ST_TextMargin.a(a.value));
        }
    }
    ST_TextMargin.$t = markStruct(ST_TextMargin, 'ST_TextMargin');
    return ST_TextMargin;
})();
