/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { UltraCalcConditionalFunctionBase } from "./UltraCalcConditionalFunctionBase";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
export let UltraCalcFunctionAverageIfs = /*@__PURE__*/ (() => {
    class UltraCalcFunctionAverageIfs extends BuiltInFunctionBase {
        evaluate(a, b) {
            return UltraCalcConditionalFunctionBase._ak(a, b, 0, (c, d) => new ExcelCalcValue(d == 0 ? new ExcelCalcErrorValue(2) : (c / d)), (c, d) => c + d);
        }
        get_name() {
            return "averageifs";
        }
        get name() {
            return this.get_name();
        }
        get_minArgs() {
            return 3;
        }
        get minArgs() {
            return this.get_minArgs();
        }
        get_maxArgs() {
            return 0x7FFFFFFF;
        }
        get maxArgs() {
            return this.get_maxArgs();
        }
    }
    UltraCalcFunctionAverageIfs.$t = markType(UltraCalcFunctionAverageIfs, 'UltraCalcFunctionAverageIfs', BuiltInFunctionBase.$);
    return UltraCalcFunctionAverageIfs;
})();
