/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, callStaticConstructors, markType } from "igniteui-angular-core";
import { UltraCalcFunctionFactory } from "./UltraCalcFunctionFactory";
import { UltraCalcFunctionSum } from "./UltraCalcFunctionSum";
import { UltraCalcFunctionCeilingPrecise } from "./UltraCalcFunctionCeilingPrecise";
import { UltraCalcFunctionAverageA } from "./UltraCalcFunctionAverageA";
import { UltraCalcFunctionIsoCeiling } from "./UltraCalcFunctionIsoCeiling";
import { UltraCalcFunctionEcmaCeiling } from "./UltraCalcFunctionEcmaCeiling";
import { UltraCalcFunctionCeilingMath } from "./UltraCalcFunctionCeilingMath";
import { UltraCalcFunctionFloorPrecise } from "./UltraCalcFunctionFloorPrecise";
import { UltraCalcFunctionFloorMath } from "./UltraCalcFunctionFloorMath";
import { UltraCalcFunctionNumberValue } from "./UltraCalcFunctionNumberValue";
import { UltraCalcFunctionIfs } from "./UltraCalcFunctionIfs";
import { UltraCalcFunctionSwitch } from "./UltraCalcFunctionSwitch";
import { UltraCalcFunctionConcatEx } from "./UltraCalcFunctionConcatEx";
import { UltraCalcFunctionTextJoin } from "./UltraCalcFunctionTextJoin";
import { UltraCalcFunctionCountBlank } from "./UltraCalcFunctionCountBlank";
import { UltraCalcFunctionDecimal } from "./UltraCalcFunctionDecimal";
import { UltraCalcFunctionUSDollar } from "./UltraCalcFunctionUSDollar";
import { UltraCalcFunctionDollar } from "./UltraCalcFunctionDollar";
import { UltraCalcFunctionExact } from "./UltraCalcFunctionExact";
import { UltraCalcFunctionProper } from "./UltraCalcFunctionProper";
import { UltraCalcFunctionSubstitute } from "./UltraCalcFunctionSubstitute";
import { UltraCalcFunctionMode } from "./UltraCalcFunctionMode";
import { UltraCalcFunctionModeMult } from "./UltraCalcFunctionModeMult";
import { UltraCalcFunctionModeSngl } from "./UltraCalcFunctionModeSngl";
import { UltraCalcFunctionRank } from "./UltraCalcFunctionRank";
import { UltraCalcFunctionRankEqual } from "./UltraCalcFunctionRankEqual";
import { UltraCalcFunctionRankAverage } from "./UltraCalcFunctionRankAverage";
import { UltraCalcFunctionPercentRank } from "./UltraCalcFunctionPercentRank";
import { UltraCalcFunctionPercentRankInclusive } from "./UltraCalcFunctionPercentRankInclusive";
import { UltraCalcFunctionPercentRankExclusive } from "./UltraCalcFunctionPercentRankExclusive";
import { UltraCalcFunctionDevSq } from "./UltraCalcFunctionDevSq";
import { UltraCalcFunctionSumSq } from "./UltraCalcFunctionSumSq";
import { UltraCalcFunctionVar_S } from "./UltraCalcFunctionVar_S";
import { UltraCalcFunctionVarA } from "./UltraCalcFunctionVarA";
import { UltraCalcFunctionVarP } from "./UltraCalcFunctionVarP";
import { UltraCalcFunctionVar_P } from "./UltraCalcFunctionVar_P";
import { UltraCalcFunctionVarPA } from "./UltraCalcFunctionVarPA";
import { UltraCalcFunctionStDev_S } from "./UltraCalcFunctionStDev_S";
import { UltraCalcFunctionStDevA } from "./UltraCalcFunctionStDevA";
import { UltraCalcFunctionStDevP } from "./UltraCalcFunctionStDevP";
import { UltraCalcFunctionStDev_P } from "./UltraCalcFunctionStDev_P";
import { UltraCalcFunctionStDevPA } from "./UltraCalcFunctionStDevPA";
import { UltraCalcFunctionPercentile } from "./UltraCalcFunctionPercentile";
import { UltraCalcFunctionPercentileInclusive } from "./UltraCalcFunctionPercentileInclusive";
import { UltraCalcFunctionPercentileExclusive } from "./UltraCalcFunctionPercentileExclusive";
import { UltraCalcFunctionQuartile } from "./UltraCalcFunctionQuartile";
import { UltraCalcFunctionQuartileInclusive } from "./UltraCalcFunctionQuartileInclusive";
import { UltraCalcFunctionQuartileExclusive } from "./UltraCalcFunctionQuartileExclusive";
import { UltraCalcFunctionSmall } from "./UltraCalcFunctionSmall";
import { UltraCalcFunctionLarge } from "./UltraCalcFunctionLarge";
import { UltraCalcFunctionSec } from "./UltraCalcFunctionSec";
import { UltraCalcFunctionSecH } from "./UltraCalcFunctionSecH";
import { UltraCalcFunctionCsc } from "./UltraCalcFunctionCsc";
import { UltraCalcFunctionCscH } from "./UltraCalcFunctionCscH";
import { UltraCalcFunctionCot } from "./UltraCalcFunctionCot";
import { UltraCalcFunctionCotH } from "./UltraCalcFunctionCotH";
import { UltraCalcFunctionAcot } from "./UltraCalcFunctionAcot";
import { UltraCalcFunctionAcotH } from "./UltraCalcFunctionAcotH";
import { UltraCalcFunctionBitAnd } from "./UltraCalcFunctionBitAnd";
import { UltraCalcFunctionBitOr } from "./UltraCalcFunctionBitOr";
import { UltraCalcFunctionBitXor } from "./UltraCalcFunctionBitXor";
import { UltraCalcFunctionBitLShift } from "./UltraCalcFunctionBitLShift";
import { UltraCalcFunctionBitRShift } from "./UltraCalcFunctionBitRShift";
import { UltraCalcFunctionFisher } from "./UltraCalcFunctionFisher";
import { UltraCalcFunctionFisherInv } from "./UltraCalcFunctionFisherInv";
import { UltraCalcFunctionIfNa } from "./UltraCalcFunctionIfNa";
import { UltraCalcFunctionArabic } from "./UltraCalcFunctionArabic";
import { UltraCalcFunctionXor } from "./UltraCalcFunctionXor";
import { UltraCalcFunctionSkew } from "./UltraCalcFunctionSkew";
import { UltraCalcFunctionSkew_P } from "./UltraCalcFunctionSkew_P";
import { UltraCalcFunctionClean } from "./UltraCalcFunctionClean";
import { UltraCalcFunctionBase } from "./UltraCalcFunctionBase";
import { UltraCalcFunctionStandardize } from "./UltraCalcFunctionStandardize";
import { UltraCalcFunctionEffect } from "./UltraCalcFunctionEffect";
import { UltraCalcFunctionNominal } from "./UltraCalcFunctionNominal";
import { UltraCalcFunctionRRI } from "./UltraCalcFunctionRRI";
import { UltraCalcFunctionPDuration } from "./UltraCalcFunctionPDuration";
import { UltraCalcFunctionDays } from "./UltraCalcFunctionDays";
import { UltraCalcFunctionYearFrac } from "./UltraCalcFunctionYearFrac";
import { UltraCalcFunctionProbFunction } from "./UltraCalcFunctionProbFunction";
import { UltraCalcFunctionPermutationA } from "./UltraCalcFunctionPermutationA";
import { UltraCalcFunctionPermut } from "./UltraCalcFunctionPermut";
import { UltraCalcFunctionPoisson } from "./UltraCalcFunctionPoisson";
import { UltraCalcFunctionPoissonDist } from "./UltraCalcFunctionPoissonDist";
import { UltraCalcFunctionErf } from "./UltraCalcFunctionErf";
import { UltraCalcFunctionErfPrecise } from "./UltraCalcFunctionErfPrecise";
import { UltraCalcFunctionErfc } from "./UltraCalcFunctionErfc";
import { UltraCalcFunctionErfcPrecise } from "./UltraCalcFunctionErfcPrecise";
import { UltraCalcFunctionExponDist } from "./UltraCalcFunctionExponDist";
import { UltraCalcFunctionExpon_Dist } from "./UltraCalcFunctionExpon_Dist";
import { UltraCalcFunctionWeibull } from "./UltraCalcFunctionWeibull";
import { UltraCalcFunctionWeibullDist } from "./UltraCalcFunctionWeibullDist";
import { UltraCalcFunctionTrimMean } from "./UltraCalcFunctionTrimMean";
import { UltraCalcFunctionIsFormula } from "./UltraCalcFunctionIsFormula";
import { UltraCalcFunctionFormulaText } from "./UltraCalcFunctionFormulaText";
import { UltraCalcFunctionAverageIfs } from "./UltraCalcFunctionAverageIfs";
import { UltraCalcFunctionCountIfs } from "./UltraCalcFunctionCountIfs";
import { UltraCalcFunctionMaxIfs } from "./UltraCalcFunctionMaxIfs";
import { UltraCalcFunctionMinIfs } from "./UltraCalcFunctionMinIfs";
import { UltraCalcFunctionSumIfs } from "./UltraCalcFunctionSumIfs";
import { UltraCalcFunctionCovarianceP } from "./UltraCalcFunctionCovarianceP";
import { UltraCalcFunctionCovarianceS } from "./UltraCalcFunctionCovarianceS";
import { UltraCalcFunctionSheet } from "./UltraCalcFunctionSheet";
import { UltraCalcFunctionSheets } from "./UltraCalcFunctionSheets";
import { UltraCalcFunctionCell } from "./UltraCalcFunctionCell";
import { UltraCalcFunctionAverage } from "./UltraCalcFunctionAverage";
import { UltraCalcFunctionIf } from "./UltraCalcFunctionIf";
import { UltraCalcFunctionAbs } from "./UltraCalcFunctionAbs";
import { UltraCalcFunctionMod } from "./UltraCalcFunctionMod";
import { UltraCalcFunctionQuotient } from "./UltraCalcFunctionQuotient";
import { UltraCalcFunctionProduct } from "./UltraCalcFunctionProduct";
import { UltraCalcFunctionPower } from "./UltraCalcFunctionPower";
import { UltraCalcFunctionInt } from "./UltraCalcFunctionInt";
import { UltraCalcFunctionCount } from "./UltraCalcFunctionCount";
import { UltraCalcFunctionTrue } from "./UltraCalcFunctionTrue";
import { UltraCalcFunctionFalse } from "./UltraCalcFunctionFalse";
import { UltraCalcFunctionAnd } from "./UltraCalcFunctionAnd";
import { UltraCalcFunctionOr } from "./UltraCalcFunctionOr";
import { UltraCalcFunctionNot } from "./UltraCalcFunctionNot";
import { UltraCalcFunctionMax } from "./UltraCalcFunctionMax";
import { UltraCalcFunctionMin } from "./UltraCalcFunctionMin";
import { UltraCalcFunctionMedian } from "./UltraCalcFunctionMedian";
import { UltraCalcFunctionVar } from "./UltraCalcFunctionVar";
import { UltraCalcFunctionStdev } from "./UltraCalcFunctionStdev";
import { UltraCalcFunctionRound } from "./UltraCalcFunctionRound";
import { UltraCalcFunctionExp } from "./UltraCalcFunctionExp";
import { UltraCalcFunctionPi } from "./UltraCalcFunctionPi";
import { UltraCalcFunctionSqrt } from "./UltraCalcFunctionSqrt";
import { UltraCalcFunctionCos } from "./UltraCalcFunctionCos";
import { UltraCalcFunctionCosh } from "./UltraCalcFunctionCosh";
import { UltraCalcFunctionACos } from "./UltraCalcFunctionACos";
import { UltraCalcFunctionSin } from "./UltraCalcFunctionSin";
import { UltraCalcFunctionSinh } from "./UltraCalcFunctionSinh";
import { UltraCalcFunctionASin } from "./UltraCalcFunctionASin";
import { UltraCalcFunctionTan } from "./UltraCalcFunctionTan";
import { UltraCalcFunctionTanh } from "./UltraCalcFunctionTanh";
import { UltraCalcFunctionATan } from "./UltraCalcFunctionATan";
import { UltraCalcFunctionATan2 } from "./UltraCalcFunctionATan2";
import { UltraCalcFunctionFloor } from "./UltraCalcFunctionFloor";
import { UltraCalcFunctionCeiling } from "./UltraCalcFunctionCeiling";
import { UltraCalcFunctionRand } from "./UltraCalcFunctionRand";
import { UltraCalcFunctionLn } from "./UltraCalcFunctionLn";
import { UltraCalcFunctionLog } from "./UltraCalcFunctionLog";
import { UltraCalcFunctionLog10 } from "./UltraCalcFunctionLog10";
import { UltraCalcFunctionNPV } from "./UltraCalcFunctionNPV";
import { UltraCalcFunctionFV } from "./UltraCalcFunctionFV";
import { UltraCalcFunctionPV } from "./UltraCalcFunctionPV";
import { UltraCalcFunctionPmt } from "./UltraCalcFunctionPmt";
import { UltraCalcFunctionNPer } from "./UltraCalcFunctionNPer";
import { UltraCalcFunctionTrunc } from "./UltraCalcFunctionTrunc";
import { UltraCalcFunctionEven } from "./UltraCalcFunctionEven";
import { UltraCalcFunctionOdd } from "./UltraCalcFunctionOdd";
import { UltraCalcFunctionPPmt } from "./UltraCalcFunctionPPmt";
import { UltraCalcFunctionIPmt } from "./UltraCalcFunctionIPmt";
import { UltraCalcFunctionConcatenate } from "./UltraCalcFunctionConcatenate";
import { UltraCalcFunctionLower } from "./UltraCalcFunctionLower";
import { UltraCalcFunctionUpper } from "./UltraCalcFunctionUpper";
import { UltraCalcFunctionLeft } from "./UltraCalcFunctionLeft";
import { UltraCalcFunctionRight } from "./UltraCalcFunctionRight";
import { UltraCalcFunctionMid } from "./UltraCalcFunctionMid";
import { UltraCalcFunctionLen } from "./UltraCalcFunctionLen";
import { UltraCalcFunctionTrim } from "./UltraCalcFunctionTrim";
import { UltraCalcFunctionValue } from "./UltraCalcFunctionValue";
import { UltraCalcFunctionFind } from "./UltraCalcFunctionFind";
import { UltraCalcFunctionReplace } from "./UltraCalcFunctionReplace";
import { UltraCalcFunctionSYD } from "./UltraCalcFunctionSYD";
import { UltraCalcFunctionSLN } from "./UltraCalcFunctionSLN";
import { UltraCalcFunctionDB } from "./UltraCalcFunctionDB";
import { UltraCalcFunctionDDB } from "./UltraCalcFunctionDDB";
import { UltraCalcFunctionIntRate } from "./UltraCalcFunctionIntRate";
import { UltraCalcFunctionDate } from "./UltraCalcFunctionDate";
import { UltraCalcFunctionDateValue } from "./UltraCalcFunctionDateValue";
import { UltraCalcFunctionDays360 } from "./UltraCalcFunctionDays360";
import { UltraCalcFunctionDay } from "./UltraCalcFunctionDay";
import { UltraCalcFunctionMonth } from "./UltraCalcFunctionMonth";
import { UltraCalcFunctionYear } from "./UltraCalcFunctionYear";
import { UltraCalcFunctionHour } from "./UltraCalcFunctionHour";
import { UltraCalcFunctionMinute } from "./UltraCalcFunctionMinute";
import { UltraCalcFunctionSecond } from "./UltraCalcFunctionSecond";
import { UltraCalcFunctionTime } from "./UltraCalcFunctionTime";
import { UltraCalcFunctionNow } from "./UltraCalcFunctionNow";
import { UltraCalcFunctionTimeValue } from "./UltraCalcFunctionTimeValue";
import { UltraCalcFunctionNa } from "./UltraCalcFunctionNa";
import { UltraCalcFunctionType } from "./UltraCalcFunctionType";
import { UltraCalcFunctionErrorType } from "./UltraCalcFunctionErrorType";
import { UltraCalcFunctionIsBlank } from "./UltraCalcFunctionIsBlank";
import { UltraCalcFunctionIsErr } from "./UltraCalcFunctionIsErr";
import { UltraCalcFunctionIsError } from "./UltraCalcFunctionIsError";
import { UltraCalcFunctionIsLogical } from "./UltraCalcFunctionIsLogical";
import { UltraCalcFunctionIsNa } from "./UltraCalcFunctionIsNa";
import { UltraCalcFunctionIsNonText } from "./UltraCalcFunctionIsNonText";
import { UltraCalcFunctionIsNumber } from "./UltraCalcFunctionIsNumber";
import { UltraCalcFunctionIsRef } from "./UltraCalcFunctionIsRef";
import { UltraCalcFunctionIsText } from "./UltraCalcFunctionIsText";
import { UltraCalcFunctionIsOdd } from "./UltraCalcFunctionIsOdd";
import { UltraCalcFunctionIsEven } from "./UltraCalcFunctionIsEven";
import { UltraCalcFunctionIRR } from "./UltraCalcFunctionIRR";
import { UltraCalcFunctionRate } from "./UltraCalcFunctionRate";
import { UltraCalcFunctionNull } from "./UltraCalcFunctionNull";
import { UltraCalcFunctionIsNull } from "./UltraCalcFunctionIsNull";
import { UltraCalcFunctionDBNull } from "./UltraCalcFunctionDBNull";
import { UltraCalcFunctionIsDBNull } from "./UltraCalcFunctionIsDBNull";
import { UltraCalcFunctionDateAdd } from "./UltraCalcFunctionDateAdd";
import { UltraCalcFunctionDateDiff } from "./UltraCalcFunctionDateDiff";
import { UltraCalcFunctionChar } from "./UltraCalcFunctionChar";
import { UltraCalcFunctionCode } from "./UltraCalcFunctionCode";
import { UltraCalcFunctionFixed } from "./UltraCalcFunctionFixed";
import { UltraCalcFunctionToday } from "./UltraCalcFunctionToday";
import { UltraCalcFunctionASinh } from "./UltraCalcFunctionASinh";
import { UltraCalcFunctionATanh } from "./UltraCalcFunctionATanh";
import { UltraCalcFunctionACosh } from "./UltraCalcFunctionACosh";
import { UltraCalcFunctionEDate } from "./UltraCalcFunctionEDate";
import { UltraCalcFunctionEOMonth } from "./UltraCalcFunctionEOMonth";
import { UltraCalcFunctionWeekDay } from "./UltraCalcFunctionWeekDay";
import { UltraCalcFunctionNetWorkDays } from "./UltraCalcFunctionNetWorkDays";
import { UltraCalcFunctionWeekNum } from "./UltraCalcFunctionWeekNum";
import { UltraCalcFunctionWorkDay } from "./UltraCalcFunctionWorkDay";
import { UltraCalcFunctionDec2Bin } from "./UltraCalcFunctionDec2Bin";
import { UltraCalcFunctionDec2Hex } from "./UltraCalcFunctionDec2Hex";
import { UltraCalcFunctionDec2Oct } from "./UltraCalcFunctionDec2Oct";
import { UltraCalcFunctionBin2Dec } from "./UltraCalcFunctionBin2Dec";
import { UltraCalcFunctionHex2Dec } from "./UltraCalcFunctionHex2Dec";
import { UltraCalcFunctionOct2Dec } from "./UltraCalcFunctionOct2Dec";
import { UltraCalcFunctionBin2Oct } from "./UltraCalcFunctionBin2Oct";
import { UltraCalcFunctionBin2Hex } from "./UltraCalcFunctionBin2Hex";
import { UltraCalcFunctionOct2Bin } from "./UltraCalcFunctionOct2Bin";
import { UltraCalcFunctionOct2Hex } from "./UltraCalcFunctionOct2Hex";
import { UltraCalcFunctionHex2Bin } from "./UltraCalcFunctionHex2Bin";
import { UltraCalcFunctionHex2Oct } from "./UltraCalcFunctionHex2Oct";
import { UltraCalcFunctionConvert } from "./UltraCalcFunctionConvert";
import { UltraCalcFunctionDelta } from "./UltraCalcFunctionDelta";
import { UltraCalcFunctionGeStep } from "./UltraCalcFunctionGeStep";
import { UltraCalcFunctionComplex } from "./UltraCalcFunctionComplex";
import { UltraCalcFunctionImAbs } from "./UltraCalcFunctionImAbs";
import { UltraCalcFunctionImaginary } from "./UltraCalcFunctionImaginary";
import { UltraCalcFunctionImReal } from "./UltraCalcFunctionImReal";
import { UltraCalcFunctionImArgument } from "./UltraCalcFunctionImArgument";
import { UltraCalcFunctionImConjugate } from "./UltraCalcFunctionImConjugate";
import { UltraCalcFunctionImCos } from "./UltraCalcFunctionImCos";
import { UltraCalcFunctionImDiv } from "./UltraCalcFunctionImDiv";
import { UltraCalcFunctionImProduct } from "./UltraCalcFunctionImProduct";
import { UltraCalcFunctionImSum } from "./UltraCalcFunctionImSum";
import { UltraCalcFunctionImSub } from "./UltraCalcFunctionImSub";
import { UltraCalcFunctionImExp } from "./UltraCalcFunctionImExp";
import { UltraCalcFunctionImLn } from "./UltraCalcFunctionImLn";
import { UltraCalcFunctionImLog10 } from "./UltraCalcFunctionImLog10";
import { UltraCalcFunctionImLog2 } from "./UltraCalcFunctionImLog2";
import { UltraCalcFunctionImSin } from "./UltraCalcFunctionImSin";
import { UltraCalcFunctionImSqrt } from "./UltraCalcFunctionImSqrt";
import { UltraCalcFunctionImPower } from "./UltraCalcFunctionImPower";
import { UltraCalcFunctionDollarFr } from "./UltraCalcFunctionDollarFr";
import { UltraCalcFunctionDollarDe } from "./UltraCalcFunctionDollarDe";
import { UltraCalcFunctionInfo } from "./UltraCalcFunctionInfo";
import { UltraCalcFunctionN } from "./UltraCalcFunctionN";
import { UltraCalcFunctionFact } from "./UltraCalcFunctionFact";
import { UltraCalcFunctionFactDouble } from "./UltraCalcFunctionFactDouble";
import { UltraCalcFunctionCombin } from "./UltraCalcFunctionCombin";
import { UltraCalcFunctionDegrees } from "./UltraCalcFunctionDegrees";
import { UltraCalcFunctionRadians } from "./UltraCalcFunctionRadians";
import { UltraCalcFunctionGcd } from "./UltraCalcFunctionGcd";
import { UltraCalcFunctionLcm } from "./UltraCalcFunctionLcm";
import { UltraCalcFunctionMultinomial } from "./UltraCalcFunctionMultinomial";
import { UltraCalcFunctionMRound } from "./UltraCalcFunctionMRound";
import { UltraCalcFunctionRandBetween } from "./UltraCalcFunctionRandBetween";
import { UltraCalcFunctionRoman } from "./UltraCalcFunctionRoman";
import { UltraCalcFunctionRoundDown } from "./UltraCalcFunctionRoundDown";
import { UltraCalcFunctionRoundUp } from "./UltraCalcFunctionRoundUp";
import { UltraCalcFunctionSeriesSum } from "./UltraCalcFunctionSeriesSum";
import { UltraCalcFunctionSign } from "./UltraCalcFunctionSign";
import { UltraCalcFunctionSqrtPi } from "./UltraCalcFunctionSqrtPi";
import { UltraCalcFunctionChoose } from "./UltraCalcFunctionChoose";
import { UltraCalcFunctionRept } from "./UltraCalcFunctionRept";
import { UltraCalcFunctionSubtotal } from "./UltraCalcFunctionSubtotal";
import { UltraCalcFunctionText } from "./UltraCalcFunctionText";
import { UltraCalcFunctionIfError } from "./UltraCalcFunctionIfError";
import { UltraCalcFunctionCountA } from "./UltraCalcFunctionCountA";
import { UltraCalcFunctionSearch } from "./UltraCalcFunctionSearch";
import { UltraCalcFunctionSearchB } from "./UltraCalcFunctionSearchB";
import { UltraCalcFunctionAveDev } from "./UltraCalcFunctionAveDev";
import { UltraCalcFunctionCombina } from "./UltraCalcFunctionCombina";
import { UltraCalcFunctionBinomDist } from "./UltraCalcFunctionBinomDist";
import { UltraCalcFunctionCritBinom } from "./UltraCalcFunctionCritBinom";
import { UltraCalcFunctionBinom_Dist } from "./UltraCalcFunctionBinom_Dist";
import { UltraCalcFunctionBinom_Dist_Range } from "./UltraCalcFunctionBinom_Dist_Range";
import { UltraCalcFunctionBinom_Inv } from "./UltraCalcFunctionBinom_Inv";
import { UltraCalcFunctionAddress } from "./UltraCalcFunctionAddress";
import { UltraCalcFunctionAreas } from "./UltraCalcFunctionAreas";
import { UltraCalcFunctionAverageIf } from "./UltraCalcFunctionAverageIf";
import { UltraCalcFunctionColumn } from "./UltraCalcFunctionColumn";
import { UltraCalcFunctionColumns } from "./UltraCalcFunctionColumns";
import { UltraCalcFunctionCorrel } from "./UltraCalcFunctionCorrel";
import { UltraCalcFunctionCountIf } from "./UltraCalcFunctionCountIf";
import { UltraCalcFunctionCovar } from "./UltraCalcFunctionCovar";
import { UltraCalcFunctionForecast } from "./UltraCalcFunctionForecast";
import { UltraCalcFunctionHLookup } from "./UltraCalcFunctionHLookup";
import { UltraCalcFunctionHyperlink } from "./UltraCalcFunctionHyperlink";
import { UltraCalcFunctionIndex } from "./UltraCalcFunctionIndex";
import { UltraCalcFunctionIndirect } from "./UltraCalcFunctionIndirect";
import { UltraCalcFunctionIntercept } from "./UltraCalcFunctionIntercept";
import { UltraCalcFunctionLookup } from "./UltraCalcFunctionLookup";
import { UltraCalcFunctionMatch } from "./UltraCalcFunctionMatch";
import { UltraCalcFunctionMdeterm } from "./UltraCalcFunctionMdeterm";
import { UltraCalcFunctionMinverse } from "./UltraCalcFunctionMinverse";
import { UltraCalcFunctionMmult } from "./UltraCalcFunctionMmult";
import { UltraCalcFunctionOffset } from "./UltraCalcFunctionOffset";
import { UltraCalcFunctionPearson } from "./UltraCalcFunctionPearson";
import { UltraCalcFunctionRow } from "./UltraCalcFunctionRow";
import { UltraCalcFunctionRows } from "./UltraCalcFunctionRows";
import { UltraCalcFunctionRsq } from "./UltraCalcFunctionRsq";
import { UltraCalcFunctionSlope } from "./UltraCalcFunctionSlope";
import { UltraCalcFunctionSteyx } from "./UltraCalcFunctionSteyx";
import { UltraCalcFunctionSumIf } from "./UltraCalcFunctionSumIf";
import { UltraCalcFunctionSumproduct } from "./UltraCalcFunctionSumproduct";
import { UltraCalcFunctionSumx2my2 } from "./UltraCalcFunctionSumx2my2";
import { UltraCalcFunctionSumx2py2 } from "./UltraCalcFunctionSumx2py2";
import { UltraCalcFunctionSumxmy2 } from "./UltraCalcFunctionSumxmy2";
import { UltraCalcFunctionTranspose } from "./UltraCalcFunctionTranspose";
import { UltraCalcFunctionVLookup } from "./UltraCalcFunctionVLookup";
import { UltraCalcFunctionDateDif } from "./UltraCalcFunctionDateDif";
/**
 * @hidden
 */
export let UltraCalcFunctionLoader = /*@__PURE__*/ (() => {
    class UltraCalcFunctionLoader extends Base {
        static staticInit() {
            UltraCalcFunctionLoader.b();
        }
        static b() {
            UltraCalcFunctionFactory._f = (a) => {
                a._g(new UltraCalcFunctionSum());
                a._g(new UltraCalcFunctionAverage());
                a._g(new UltraCalcFunctionIf());
                a._g(new UltraCalcFunctionAbs());
                a._g(new UltraCalcFunctionMod());
                a._g(new UltraCalcFunctionQuotient());
                a._g(new UltraCalcFunctionProduct());
                a._g(new UltraCalcFunctionPower());
                a._g(new UltraCalcFunctionInt());
                a._g(new UltraCalcFunctionCount());
                a._g(new UltraCalcFunctionTrue());
                a._g(new UltraCalcFunctionFalse());
                a._g(new UltraCalcFunctionAnd());
                a._g(new UltraCalcFunctionOr());
                a._g(new UltraCalcFunctionNot());
                a._g(new UltraCalcFunctionMax());
                a._g(new UltraCalcFunctionMin());
                a._g(new UltraCalcFunctionMedian());
                a._g(new UltraCalcFunctionVar());
                a._g(new UltraCalcFunctionStdev());
                a._g(new UltraCalcFunctionRound());
                a._g(new UltraCalcFunctionExp());
                a._g(new UltraCalcFunctionPi());
                a._g(new UltraCalcFunctionSqrt());
                a._g(new UltraCalcFunctionCos());
                a._g(new UltraCalcFunctionCosh());
                a._g(new UltraCalcFunctionACos());
                a._g(new UltraCalcFunctionSin());
                a._g(new UltraCalcFunctionSinh());
                a._g(new UltraCalcFunctionASin());
                a._g(new UltraCalcFunctionTan());
                a._g(new UltraCalcFunctionTanh());
                a._g(new UltraCalcFunctionATan());
                a._g(new UltraCalcFunctionATan2());
                a._g(new UltraCalcFunctionFloor());
                a._g(new UltraCalcFunctionCeiling());
                a._g(new UltraCalcFunctionRand());
                a._g(new UltraCalcFunctionLn());
                a._g(new UltraCalcFunctionLog());
                a._g(new UltraCalcFunctionLog10());
                a._g(new UltraCalcFunctionNPV());
                a._g(new UltraCalcFunctionFV());
                a._g(new UltraCalcFunctionPV());
                a._g(new UltraCalcFunctionPmt());
                a._g(new UltraCalcFunctionNPer());
                a._g(new UltraCalcFunctionTrunc());
                a._g(new UltraCalcFunctionEven());
                a._g(new UltraCalcFunctionOdd());
                a._g(new UltraCalcFunctionPPmt());
                a._g(new UltraCalcFunctionIPmt());
                a._g(new UltraCalcFunctionConcatenate());
                a._g(new UltraCalcFunctionLower());
                a._g(new UltraCalcFunctionUpper());
                a._g(new UltraCalcFunctionLeft());
                a._g(new UltraCalcFunctionRight());
                a._g(new UltraCalcFunctionMid());
                a._g(new UltraCalcFunctionLen());
                a._g(new UltraCalcFunctionTrim());
                a._g(new UltraCalcFunctionValue());
                a._g(new UltraCalcFunctionFind());
                a._g(new UltraCalcFunctionReplace());
                a._g(new UltraCalcFunctionSYD());
                a._g(new UltraCalcFunctionSLN());
                a._g(new UltraCalcFunctionDB());
                a._g(new UltraCalcFunctionDDB());
                a._g(new UltraCalcFunctionIntRate());
                a._g(new UltraCalcFunctionDate());
                a._g(new UltraCalcFunctionDateValue());
                a._g(new UltraCalcFunctionDays360());
                a._g(new UltraCalcFunctionDay());
                a._g(new UltraCalcFunctionMonth());
                a._g(new UltraCalcFunctionYear());
                a._g(new UltraCalcFunctionHour());
                a._g(new UltraCalcFunctionMinute());
                a._g(new UltraCalcFunctionSecond());
                a._g(new UltraCalcFunctionTime());
                a._g(new UltraCalcFunctionNow());
                a._g(new UltraCalcFunctionTimeValue());
                a._g(new UltraCalcFunctionNa());
                a._g(new UltraCalcFunctionType());
                a._g(new UltraCalcFunctionErrorType());
                a._g(new UltraCalcFunctionIsBlank());
                a._g(new UltraCalcFunctionIsErr());
                a._g(new UltraCalcFunctionIsError());
                a._g(new UltraCalcFunctionIsLogical());
                a._g(new UltraCalcFunctionIsNa());
                a._g(new UltraCalcFunctionIsNonText());
                a._g(new UltraCalcFunctionIsNumber());
                a._g(new UltraCalcFunctionIsRef());
                a._g(new UltraCalcFunctionIsText());
                a._g(new UltraCalcFunctionIsOdd());
                a._g(new UltraCalcFunctionIsEven());
                a._g(new UltraCalcFunctionIRR());
                a._g(new UltraCalcFunctionRate());
                a._g(new UltraCalcFunctionNull());
                a._g(new UltraCalcFunctionIsNull());
                a._g(new UltraCalcFunctionDBNull());
                a._g(new UltraCalcFunctionIsDBNull());
                a._g(new UltraCalcFunctionDateAdd());
                a._g(new UltraCalcFunctionDateDiff());
                a._g(new UltraCalcFunctionChar());
                a._g(new UltraCalcFunctionCode());
                a._g(new UltraCalcFunctionFixed());
                a._g(new UltraCalcFunctionToday());
                a._g(new UltraCalcFunctionASinh());
                a._g(new UltraCalcFunctionATanh());
                a._g(new UltraCalcFunctionACosh());
                a._g(new UltraCalcFunctionEDate());
                a._g(new UltraCalcFunctionEOMonth());
                a._g(new UltraCalcFunctionWeekDay());
                a._g(new UltraCalcFunctionNetWorkDays());
                a._g(new UltraCalcFunctionWeekNum());
                a._g(new UltraCalcFunctionWorkDay());
                a._g(new UltraCalcFunctionDec2Bin());
                a._g(new UltraCalcFunctionDec2Hex());
                a._g(new UltraCalcFunctionDec2Oct());
                a._g(new UltraCalcFunctionBin2Dec());
                a._g(new UltraCalcFunctionHex2Dec());
                a._g(new UltraCalcFunctionOct2Dec());
                a._g(new UltraCalcFunctionBin2Oct());
                a._g(new UltraCalcFunctionBin2Hex());
                a._g(new UltraCalcFunctionOct2Bin());
                a._g(new UltraCalcFunctionOct2Hex());
                a._g(new UltraCalcFunctionHex2Bin());
                a._g(new UltraCalcFunctionHex2Oct());
                a._g(new UltraCalcFunctionConvert());
                a._g(new UltraCalcFunctionDelta());
                a._g(new UltraCalcFunctionGeStep());
                a._g(new UltraCalcFunctionComplex());
                a._g(new UltraCalcFunctionImAbs());
                a._g(new UltraCalcFunctionImaginary());
                a._g(new UltraCalcFunctionImReal());
                a._g(new UltraCalcFunctionImArgument());
                a._g(new UltraCalcFunctionImConjugate());
                a._g(new UltraCalcFunctionImCos());
                a._g(new UltraCalcFunctionImDiv());
                a._g(new UltraCalcFunctionImProduct());
                a._g(new UltraCalcFunctionImSum());
                a._g(new UltraCalcFunctionImSub());
                a._g(new UltraCalcFunctionImExp());
                a._g(new UltraCalcFunctionImLn());
                a._g(new UltraCalcFunctionImLog10());
                a._g(new UltraCalcFunctionImLog2());
                a._g(new UltraCalcFunctionImSin());
                a._g(new UltraCalcFunctionImSqrt());
                a._g(new UltraCalcFunctionImPower());
                a._g(new UltraCalcFunctionDollarFr());
                a._g(new UltraCalcFunctionDollarDe());
                a._g(new UltraCalcFunctionInfo());
                a._g(new UltraCalcFunctionN());
                a._g(new UltraCalcFunctionFact());
                a._g(new UltraCalcFunctionFactDouble());
                a._g(new UltraCalcFunctionCombin());
                a._g(new UltraCalcFunctionDegrees());
                a._g(new UltraCalcFunctionRadians());
                a._g(new UltraCalcFunctionGcd());
                a._g(new UltraCalcFunctionLcm());
                a._g(new UltraCalcFunctionMultinomial());
                a._g(new UltraCalcFunctionMRound());
                a._g(new UltraCalcFunctionRandBetween());
                a._g(new UltraCalcFunctionRoman());
                a._g(new UltraCalcFunctionRoundDown());
                a._g(new UltraCalcFunctionRoundUp());
                a._g(new UltraCalcFunctionSeriesSum());
                a._g(new UltraCalcFunctionSign());
                a._g(new UltraCalcFunctionSqrtPi());
                a._g(new UltraCalcFunctionChoose());
                a._g(new UltraCalcFunctionRept());
                a._g(new UltraCalcFunctionSubtotal());
                a._g(new UltraCalcFunctionText());
                a._g(new UltraCalcFunctionIfError());
                a._g(new UltraCalcFunctionCountA());
                a._g(new UltraCalcFunctionSearch());
                a._g(new UltraCalcFunctionSearchB());
                a._g(new UltraCalcFunctionAveDev());
                a._g(new UltraCalcFunctionCombina());
                a._g(new UltraCalcFunctionBinomDist());
                a._g(new UltraCalcFunctionCritBinom());
                a._g(new UltraCalcFunctionBinom_Dist());
                a._g(new UltraCalcFunctionBinom_Dist_Range());
                a._g(new UltraCalcFunctionBinom_Inv());
                a._g(new UltraCalcFunctionAddress());
                a._g(new UltraCalcFunctionAreas());
                a._g(new UltraCalcFunctionAverageIf());
                a._g(new UltraCalcFunctionColumn());
                a._g(new UltraCalcFunctionColumns());
                a._g(new UltraCalcFunctionCorrel());
                a._g(new UltraCalcFunctionCountIf());
                a._g(new UltraCalcFunctionCovar());
                a._g(new UltraCalcFunctionForecast());
                a._g(new UltraCalcFunctionHLookup());
                a._g(new UltraCalcFunctionHyperlink());
                a._g(new UltraCalcFunctionIndex());
                a._g(new UltraCalcFunctionIndirect());
                a._g(new UltraCalcFunctionIntercept());
                a._g(new UltraCalcFunctionLookup());
                a._g(new UltraCalcFunctionMatch());
                a._g(new UltraCalcFunctionMdeterm());
                a._g(new UltraCalcFunctionMinverse());
                a._g(new UltraCalcFunctionMmult());
                a._g(new UltraCalcFunctionOffset());
                a._g(new UltraCalcFunctionPearson());
                a._g(new UltraCalcFunctionRow());
                a._g(new UltraCalcFunctionRows());
                a._g(new UltraCalcFunctionRsq());
                a._g(new UltraCalcFunctionSlope());
                a._g(new UltraCalcFunctionSteyx());
                a._g(new UltraCalcFunctionSumIf());
                a._g(new UltraCalcFunctionSumproduct());
                a._g(new UltraCalcFunctionSumx2my2());
                a._g(new UltraCalcFunctionSumx2py2());
                a._g(new UltraCalcFunctionSumxmy2());
                a._g(new UltraCalcFunctionTranspose());
                a._g(new UltraCalcFunctionVLookup());
                a._g(new UltraCalcFunctionDateDif());
                UltraCalcFunctionLoader.a(a);
            };
        }
        static a(a) {
            a._g(new UltraCalcFunctionCeilingPrecise());
            a._g(new UltraCalcFunctionAverageA());
            a._g(new UltraCalcFunctionIsoCeiling());
            a._g(new UltraCalcFunctionEcmaCeiling());
            a._g(new UltraCalcFunctionCeilingMath());
            a._g(new UltraCalcFunctionFloorPrecise());
            a._g(new UltraCalcFunctionFloorMath());
            a._g(new UltraCalcFunctionNumberValue());
            a._g(new UltraCalcFunctionIfs());
            a._g(new UltraCalcFunctionSwitch());
            a._g(new UltraCalcFunctionConcatEx());
            a._g(new UltraCalcFunctionTextJoin());
            a._g(new UltraCalcFunctionCountBlank());
            a._g(new UltraCalcFunctionDecimal());
            a._g(new UltraCalcFunctionUSDollar());
            a._g(new UltraCalcFunctionDollar());
            a._g(new UltraCalcFunctionExact());
            a._g(new UltraCalcFunctionProper());
            a._g(new UltraCalcFunctionSubstitute());
            a._g(new UltraCalcFunctionMode());
            a._g(new UltraCalcFunctionModeMult());
            a._g(new UltraCalcFunctionModeSngl());
            a._g(new UltraCalcFunctionRank());
            a._g(new UltraCalcFunctionRankEqual());
            a._g(new UltraCalcFunctionRankAverage());
            a._g(new UltraCalcFunctionPercentRank());
            a._g(new UltraCalcFunctionPercentRankInclusive());
            a._g(new UltraCalcFunctionPercentRankExclusive());
            a._g(new UltraCalcFunctionDevSq());
            a._g(new UltraCalcFunctionSumSq());
            a._g(new UltraCalcFunctionVar_S());
            a._g(new UltraCalcFunctionVarA());
            a._g(new UltraCalcFunctionVarP());
            a._g(new UltraCalcFunctionVar_P());
            a._g(new UltraCalcFunctionVarPA());
            a._g(new UltraCalcFunctionStDev_S());
            a._g(new UltraCalcFunctionStDevA());
            a._g(new UltraCalcFunctionStDevP());
            a._g(new UltraCalcFunctionStDev_P());
            a._g(new UltraCalcFunctionStDevPA());
            a._g(new UltraCalcFunctionPercentile());
            a._g(new UltraCalcFunctionPercentileInclusive());
            a._g(new UltraCalcFunctionPercentileExclusive());
            a._g(new UltraCalcFunctionQuartile());
            a._g(new UltraCalcFunctionQuartileInclusive());
            a._g(new UltraCalcFunctionQuartileExclusive());
            a._g(new UltraCalcFunctionSmall());
            a._g(new UltraCalcFunctionLarge());
            a._g(new UltraCalcFunctionSec());
            a._g(new UltraCalcFunctionSecH());
            a._g(new UltraCalcFunctionCsc());
            a._g(new UltraCalcFunctionCscH());
            a._g(new UltraCalcFunctionCot());
            a._g(new UltraCalcFunctionCotH());
            a._g(new UltraCalcFunctionAcot());
            a._g(new UltraCalcFunctionAcotH());
            a._g(new UltraCalcFunctionBitAnd());
            a._g(new UltraCalcFunctionBitOr());
            a._g(new UltraCalcFunctionBitXor());
            a._g(new UltraCalcFunctionBitLShift());
            a._g(new UltraCalcFunctionBitRShift());
            a._g(new UltraCalcFunctionFisher());
            a._g(new UltraCalcFunctionFisherInv());
            a._g(new UltraCalcFunctionIfNa());
            a._g(new UltraCalcFunctionArabic());
            a._g(new UltraCalcFunctionXor());
            a._g(new UltraCalcFunctionSkew());
            a._g(new UltraCalcFunctionSkew_P());
            a._g(new UltraCalcFunctionClean());
            a._g(new UltraCalcFunctionBase());
            a._g(new UltraCalcFunctionStandardize());
            a._g(new UltraCalcFunctionEffect());
            a._g(new UltraCalcFunctionNominal());
            a._g(new UltraCalcFunctionRRI());
            a._g(new UltraCalcFunctionPDuration());
            a._g(new UltraCalcFunctionDays());
            a._g(new UltraCalcFunctionYearFrac());
            a._g(new UltraCalcFunctionProbFunction());
            a._g(new UltraCalcFunctionPermutationA());
            a._g(new UltraCalcFunctionPermut());
            a._g(new UltraCalcFunctionPoisson());
            a._g(new UltraCalcFunctionPoissonDist());
            a._g(new UltraCalcFunctionErf());
            a._g(new UltraCalcFunctionErfPrecise());
            a._g(new UltraCalcFunctionErfc());
            a._g(new UltraCalcFunctionErfcPrecise());
            a._g(new UltraCalcFunctionExponDist());
            a._g(new UltraCalcFunctionExpon_Dist());
            a._g(new UltraCalcFunctionWeibull());
            a._g(new UltraCalcFunctionWeibullDist());
            a._g(new UltraCalcFunctionTrimMean());
            a._g(new UltraCalcFunctionIsFormula());
            a._g(new UltraCalcFunctionFormulaText());
            a._g(new UltraCalcFunctionAverageIfs());
            a._g(new UltraCalcFunctionCountIfs());
            a._g(new UltraCalcFunctionMaxIfs());
            a._g(new UltraCalcFunctionMinIfs());
            a._g(new UltraCalcFunctionSumIfs());
            a._g(new UltraCalcFunctionCovarianceP());
            a._g(new UltraCalcFunctionCovarianceS());
            a._g(new UltraCalcFunctionSheet());
            a._g(new UltraCalcFunctionSheets());
            a._g(new UltraCalcFunctionCell());
        }
    }
    UltraCalcFunctionLoader.$t = markType(UltraCalcFunctionLoader, 'UltraCalcFunctionLoader');
    return UltraCalcFunctionLoader;
})();
(function (v) { callStaticConstructors(); })(true);
