/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { UltraCalcFunctionTwoMatrixFunction } from "./UltraCalcFunctionTwoMatrixFunction";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let UltraCalcFunctionPearson = /*@__PURE__*/ (() => {
    class UltraCalcFunctionPearson extends UltraCalcFunctionTwoMatrixFunction {
        evaluate(a, b) {
            let c;
            let d = ((() => { let e = UltraCalcFunctionTwoMatrixFunction._al(a, c); c = e.p1; return e.ret; })());
            if (c != null) {
                return new ExcelCalcValue(c);
            }
            return new ExcelCalcValue(d);
        }
        get_name() {
            return "pearson";
        }
        get name() {
            return this.get_name();
        }
    }
    UltraCalcFunctionPearson.$t = markType(UltraCalcFunctionPearson, 'UltraCalcFunctionPearson', UltraCalcFunctionTwoMatrixFunction.$);
    return UltraCalcFunctionPearson;
})();
