/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, toNullable, Number_$type, fromEnum, markType, getInstanceType } from "igniteui-angular-core";
import { ST_MarkerStyle_$type } from "./ST_MarkerStyle";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { CultureInfo } from "igniteui-angular-core";
import { parseUInt8_1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var CT_MarkerLayout = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_MarkerLayout, _super);
    function CT_MarkerLayout() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.d = toNullable(ST_MarkerStyle_$type, null);
        _this.b = toNullable(Number_$type, null);
        return _this;
    }
    Object.defineProperty(CT_MarkerLayout.prototype, "c", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_MarkerLayout.prototype, "a", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: false,
        configurable: true
    });
    CT_MarkerLayout.f = function (a, b, c) {
        var e_1, _a;
        b = toNullable(ST_MarkerStyle_$type, null);
        c = toNullable(Number_$type, null);
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                switch (d.a.e(a.d)) {
                    case "symbol":
                        b = toNullable(ST_MarkerStyle_$type, XmlNamespaceDefinitionBase.b(ST_MarkerStyle_$type, d.d));
                        break;
                    case "size":
                        c = toNullable(Number_$type, parseUInt8_1(d.d, CultureInfo.invariantCulture));
                        break;
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        ;
        return {
            p1: b,
            p2: c
        };
    };
    CT_MarkerLayout.g = function (a, b, c, d) {
        if (c === void 0) {
            c = toNullable(Number_$type, null);
        }
        if (d === void 0) {
            d = toNullable(ST_MarkerStyle_$type, null);
        }
        a.ad.p(b, "cs");
        var e = null;
        var f = null;
        if (c.hasValue) {
            f = "size";
            e = c.value.toString();
            a.ad.h(f, e);
        }
        if (d.hasValue) {
            f = "symbol";
            e = XmlNamespaceDefinitionBase.p(ST_MarkerStyle_$type, d.value);
            a.ad.h(f, e);
        }
        ;
    };
    CT_MarkerLayout.prototype.toString = function () {
        var a = getInstanceType(this);
        return a != null ? a.typeName : _super.prototype.toString.call(this);
    };
    CT_MarkerLayout.$t = markType(CT_MarkerLayout, 'CT_MarkerLayout');
    return CT_MarkerLayout;
}(Base));
export { CT_MarkerLayout };
