/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, toNullable, markType } from "igniteui-angular-core";
import { IAdjustHandle_$type } from "./IAdjustHandle";
import { ST_GeomGuideName } from "./ST_GeomGuideName";
import { ST_AdjCoordinate } from "./ST_AdjCoordinate";
import { ST_AdjAngle } from "./ST_AdjAngle";
/**
 * @hidden
 */
var CT_PolarAdjustHandle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_PolarAdjustHandle, _super);
    function CT_PolarAdjustHandle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.a = null;
        _this.c = toNullable(ST_GeomGuideName.$, null);
        _this.g = toNullable(ST_AdjCoordinate.$, null);
        _this.e = toNullable(ST_AdjCoordinate.$, null);
        _this.b = toNullable(ST_GeomGuideName.$, null);
        _this.f = toNullable(ST_AdjAngle.$, null);
        _this.d = toNullable(ST_AdjAngle.$, null);
        return _this;
    }
    CT_PolarAdjustHandle.$t = markType(CT_PolarAdjustHandle, 'CT_PolarAdjustHandle', Base.$, [IAdjustHandle_$type]);
    return CT_PolarAdjustHandle;
}(Base));
export { CT_PolarAdjustHandle };
