/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various date range types which can be filtered by the [[DatePeriodFilter]].
 * @see [[DatePeriodFilter.type]]
 */
export var DatePeriodFilterType = /*@__PURE__*/ (function (DatePeriodFilterType) {
    /**
     * Filter in dates in a specific month of any year.
     */
    DatePeriodFilterType[DatePeriodFilterType["Month"] = 0] = "Month";
    /**
     * Filter in dates in a specific quarter of any year.
     */
    DatePeriodFilterType[DatePeriodFilterType["Quarter"] = 1] = "Quarter";
    return DatePeriodFilterType;
})({});
/**
 * @hidden
 */
export var DatePeriodFilterType_$type = markEnum('DatePeriodFilterType', 'Month,0|Quarter,1');
