/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ArithmeticException } from "./ArithmeticException";
import { markType } from "igniteui-angular-core";
/**
 * Represents an error in which a division by zero occurred during calculations.
 */
var DivideByZeroException = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DivideByZeroException, _super);
    function DivideByZeroException(message, innerException) {
        var _this = _super.call(this, message, innerException) || this;
        message = (message !== void 0 ? message : null);
        innerException = (innerException !== void 0 ? innerException : null);
        return _this;
    }
    DivideByZeroException.$t = markType(DivideByZeroException, 'DivideByZeroException', ArithmeticException.$);
    return DivideByZeroException;
}(ArithmeticException));
export { DivideByZeroException };
