/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { Guid } from "igniteui-angular-core";
import { ArgumentException } from "igniteui-angular-core";
/**
 * @hidden
 */
var ImageFormat = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ImageFormat, _super);
    function ImageFormat(a) {
        var _this = _super.call(this) || this;
        _this.n = new Guid();
        _this.n = a;
        return _this;
    }
    ImageFormat.d = function (a) {
        var b;
        switch (a.toLowerCase()) {
            case "image/bmp":
                b = ImageFormat.a;
                break;
            case "image/dib":
                b = ImageFormat.b;
                break;
            case "image/emf":
                b = ImageFormat.c;
                break;
            case "image/gif":
                b = ImageFormat.e;
                break;
            case "image/jpeg":
                b = ImageFormat.f;
                break;
            case "image/png":
                b = ImageFormat.g;
                break;
            case "image/tiff":
            case "image/x-tiff":
                b = ImageFormat.h;
                break;
            case "windows/metafile":
            case "image/wmf":
                b = ImageFormat.i;
                break;
            default: throw new ArgumentException(1, "Unrecognized mediaType:" + a);
        }
        return b;
    };
    ImageFormat.s = function (a) {
        var b = null;
        if (a != null) {
            var c = a.n;
            if (Guid.l_op_Equality(c, ImageFormat.p)) {
                b = "image/png";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.o)) {
                b = "image/jpeg";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.m)) {
                b = "image/gif";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.r)) {
                b = "image/wmf";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.j)) {
                b = "image/bmp";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.q)) {
                b = "image/tiff";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.l)) {
                b = "image/emf";
            }
            else if (Guid.l_op_Equality(c, ImageFormat.k)) {
                b = "image/dib";
            }
        }
        return b;
    };
    ImageFormat.$t = markType(ImageFormat, 'ImageFormat');
    ImageFormat.j = new Guid(3, "B96B3CAA-0728-11D3-9D7B-0000F81EF32E");
    ImageFormat.k = new Guid(3, "824CA8E2-A984-4668-8A14-077225372B1C");
    ImageFormat.l = new Guid(3, "B96B3CAC-0728-11D3-9D7B-0000F81EF32E");
    ImageFormat.m = new Guid(3, "1FE88D21-FE3D-4F4A-ABD3-8DBAD86C510A");
    ImageFormat.o = new Guid(3, "0C487171-1412-4D76-B20A-4AEA380FFAA7");
    ImageFormat.p = new Guid(3, "7B369CF6-0507-4F15-ABE8-5768C70D1454");
    ImageFormat.q = new Guid(3, "069B1E5E-A617-4498-AAEA-D71AF8933FD3");
    ImageFormat.r = new Guid(3, "B96B3CAD-0728-11D3-9D7B-0000F81EF32E");
    ImageFormat.a = new ImageFormat(ImageFormat.j);
    ImageFormat.b = new ImageFormat(ImageFormat.k);
    ImageFormat.c = new ImageFormat(ImageFormat.l);
    ImageFormat.e = new ImageFormat(ImageFormat.m);
    ImageFormat.f = new ImageFormat(ImageFormat.o);
    ImageFormat.g = new ImageFormat(ImageFormat.p);
    ImageFormat.h = new ImageFormat(ImageFormat.q);
    ImageFormat.i = new ImageFormat(ImageFormat.r);
    return ImageFormat;
}(Base));
export { ImageFormat };
