/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which define the label positioning for a <i>Treemap</i> chart.
 */
export var ParentLabelLayout = /*@__PURE__*/ (function (ParentLabelLayout) {
    /**
     * Labels are not displayed.
     */
    ParentLabelLayout[ParentLabelLayout["None"] = 0] = "None";
    /**
     * Labels are displayed as banners.
     */
    ParentLabelLayout[ParentLabelLayout["Banner"] = 1] = "Banner";
    /**
     * Labels are displayed with overlapping.
     */
    ParentLabelLayout[ParentLabelLayout["Overlapping"] = 2] = "Overlapping";
    return ParentLabelLayout;
})({});
/**
 * @hidden
 */
export var ParentLabelLayout_$type = markEnum('ParentLabelLayout', 'None,0|Banner,1|Overlapping,2');
