/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the method of calculation
 * used when determining the median for a box and whisker chart.
 */
export var QuartileCalculation = /*@__PURE__*/ (function (QuartileCalculation) {
    /**
     * The median is included in the calculation if <i>n</i> (the number of values in the data) is odd.
     */
    QuartileCalculation[QuartileCalculation["InclusiveMedian"] = 0] = "InclusiveMedian";
    /**
     * The median is excluded from the calculation if <i>n</i> (the number of values in the data) is odd.
     */
    QuartileCalculation[QuartileCalculation["ExclusiveMedian"] = 1] = "ExclusiveMedian";
    return QuartileCalculation;
})({});
/**
 * @hidden
 */
export var QuartileCalculation_$type = markEnum('QuartileCalculation', 'InclusiveMedian,0|ExclusiveMedian,1');
