/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various relative date offsets which can be filtered by the [[RelativeDateRangeFilter]].
 * @see [[RelativeDateRangeFilter.offset]]
 */
export var RelativeDateRangeOffset = /*@__PURE__*/ (function (RelativeDateRangeOffset) {
    /**
     * Filter in values in the previous duration relative to the filter's creation date.
     */
    RelativeDateRangeOffset[RelativeDateRangeOffset["Previous"] = 0] = "Previous";
    /**
     * Filter in values in the current duration relative to the filter's creation date.
     */
    RelativeDateRangeOffset[RelativeDateRangeOffset["Current"] = 1] = "Current";
    /**
     * Filter in values in the next duration relative to the filter's creation date.
     */
    RelativeDateRangeOffset[RelativeDateRangeOffset["Next"] = 2] = "Next";
    return RelativeDateRangeOffset;
})({});
/**
 * @hidden
 */
export var RelativeDateRangeOffset_$type = markEnum('RelativeDateRangeOffset', 'Previous,0|Current,1|Next,2');
