/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ValueType, Base, toNullable, typeCast, Number_$type, markStruct } from "igniteui-angular-core";
import { ST_UnsignedDecimalNumber } from "./ST_UnsignedDecimalNumber";
import { DocCoreUtils } from "./DocCoreUtils";
import { nullableNotEquals } from "igniteui-angular-core";
/**
 * @hidden
 */
var ST_PointMeasure = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ST_PointMeasure, _super);
    function ST_PointMeasure(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.d = new ST_UnsignedDecimalNumber();
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    var c = _rest[0];
                    _this.d = c;
                }
                break;
        }
        return _this;
    }
    ST_PointMeasure.prototype.equals = function (a) {
        var b = toNullable(ST_PointMeasure.$, typeCast(ST_PointMeasure.$, a));
        if (ST_PointMeasure.j(b, toNullable(ST_PointMeasure.$, null))) {
            return false;
        }
        return ST_PointMeasure.g(this, b.getValueOrDefault());
    };
    ST_PointMeasure.prototype.getHashCode = function () {
        return Base.getHashCodeStatic(this.d);
    };
    ST_PointMeasure.prototype.toString = function () {
        return this.d.toString();
    };
    ST_PointMeasure.c = function (a) {
        var b = ST_PointMeasure.p(a);
        if (ST_PointMeasure.j(b, toNullable(ST_PointMeasure.$, null))) {
            return b.getValueOrDefault();
        }
        throw DocCoreUtils.n(ST_PointMeasure.$, a);
    };
    ST_PointMeasure.p = function (a) {
        var b = ST_UnsignedDecimalNumber.f(a);
        if (nullableNotEquals(b, null)) {
            return toNullable(ST_PointMeasure.$, ST_PointMeasure.a(b.getValueOrDefault()));
        }
        return toNullable(ST_PointMeasure.$, null);
    };
    ST_PointMeasure.g = function (a, b) {
        return ST_UnsignedDecimalNumber.h(a.d) == ST_UnsignedDecimalNumber.h(b.d);
    };
    ST_PointMeasure.h = function (a, b) {
        if (!a.hasValue) {
            return !b.hasValue;
        }
        else if (!b.hasValue) {
            return false;
        }
        return ST_PointMeasure.g(a.value, b.value);
    };
    ST_PointMeasure.i = function (a, b) {
        return !(ST_PointMeasure.g(a, b));
    };
    ST_PointMeasure.j = function (a, b) {
        if (!a.hasValue) {
            return b.hasValue;
        }
        else if (!b.hasValue) {
            return true;
        }
        return ST_PointMeasure.i(a.value, b.value);
    };
    ST_PointMeasure.a = function (a) {
        return new ST_PointMeasure(1, a);
    };
    ST_PointMeasure.m = function (a) {
        if (!a.hasValue) {
            return toNullable(ST_PointMeasure.$, null);
        }
        return toNullable(ST_PointMeasure.$, ST_PointMeasure.a(a.value));
    };
    ST_PointMeasure.e = function (a) {
        return a.d;
    };
    ST_PointMeasure.n = function (a) {
        if (!a.hasValue) {
            return toNullable(ST_UnsignedDecimalNumber.$, null);
        }
        return toNullable(ST_UnsignedDecimalNumber.$, ST_PointMeasure.e(a.value));
    };
    ST_PointMeasure.q = function (a) {
        return ST_UnsignedDecimalNumber.h(a.d);
    };
    ST_PointMeasure.o = function (a) {
        if (!a.hasValue) {
            return toNullable(Number_$type, null);
        }
        return toNullable(Number_$type, ST_PointMeasure.q(a.value));
    };
    ST_PointMeasure.$t = markStruct(ST_PointMeasure, 'ST_PointMeasure');
    return ST_PointMeasure;
}(ValueType));
export { ST_PointMeasure };
