/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Determines the alignment for axis [[Axis.tickLabels]]
 */
export var TickLabelAlignment = /*@__PURE__*/ (function (TickLabelAlignment) {
    /**
     * The tick labels will be aligned on the left
     */
    TickLabelAlignment[TickLabelAlignment["Left"] = -4131] = "Left";
    /**
     * The tick labels will be centered
     */
    TickLabelAlignment[TickLabelAlignment["Center"] = -4108] = "Center";
    /**
     * The tick labels will be aligned on the right
     */
    TickLabelAlignment[TickLabelAlignment["Right"] = -4152] = "Right";
    return TickLabelAlignment;
})({});
/**
 * @hidden
 */
export var TickLabelAlignment_$type = markEnum('TickLabelAlignment', 'Left,-4131|Center,-4108|Right,-4152');
