/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { UltraCalcFunctionComplex_ComplexNumber } from "./UltraCalcFunctionComplex_ComplexNumber";
import { stringCompare1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionComplex = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionComplex, _super);
    function UltraCalcFunctionComplex() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionComplex.prototype.evaluate = function (a, b) {
        var c;
        var d = (b == 3) ? a.pop().toString() : "i";
        if (stringCompare1(d, "i", 4) != 0 && stringCompare1(d, "j", 4) != 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var e = c._toDouble3();
        c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var f = c._toDouble3();
        var g = new UltraCalcFunctionComplex_ComplexNumber(0, f, e, d);
        var h = g.toString();
        return new ExcelCalcValue(h);
    };
    UltraCalcFunctionComplex.prototype.get_name = function () {
        return "complex";
    };
    Object.defineProperty(UltraCalcFunctionComplex.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionComplex.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionComplex.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionComplex.prototype.get_maxArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionComplex.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionComplex.$t = markType(UltraCalcFunctionComplex, 'UltraCalcFunctionComplex', BuiltInFunctionBase.$);
    return UltraCalcFunctionComplex;
}(BuiltInFunctionBase));
export { UltraCalcFunctionComplex };
