/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionDevSq = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionDevSq, _super);
    function UltraCalcFunctionDevSq() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionDevSq.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.d(a, b, 1229, function (c) {
            if (c.count == 0) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(2));
            }
            else if (c.count == 1) {
                return new ExcelCalcValue(0);
            }
            var d = CalcFunctionUtilities.r(c);
            return new ExcelCalcValue(d);
        });
    };
    UltraCalcFunctionDevSq.prototype.get_name = function () {
        return "devsq";
    };
    Object.defineProperty(UltraCalcFunctionDevSq.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDevSq.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionDevSq.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDevSq.prototype.get_maxArgs = function () {
        return 0x7FFFFFFF;
    };
    Object.defineProperty(UltraCalcFunctionDevSq.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDevSq.$t = markType(UltraCalcFunctionDevSq, 'UltraCalcFunctionDevSq', BuiltInFunctionBase.$);
    return UltraCalcFunctionDevSq;
}(BuiltInFunctionBase));
export { UltraCalcFunctionDevSq };
