/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { CalcManagerUtilities } from "./CalcManagerUtilities";
import { markType } from "igniteui-angular-core";
import { dateGetDate } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionEDate = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionEDate, _super);
    function UltraCalcFunctionEDate() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionEDate.prototype.evaluate = function (a, b) {
        var c = a.pop()._toDouble3();
        var d = dateGetDate(a.pop()._toDateTime1());
        d = CalcManagerUtilities.b(2, c, d);
        return new ExcelCalcValue(d);
    };
    UltraCalcFunctionEDate.prototype.get_name = function () {
        return "edate";
    };
    Object.defineProperty(UltraCalcFunctionEDate.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEDate.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEDate.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEDate.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionEDate.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionEDate.$t = markType(UltraCalcFunctionEDate, 'UltraCalcFunctionEDate', BuiltInFunctionBase.$);
    return UltraCalcFunctionEDate;
}(BuiltInFunctionBase));
export { UltraCalcFunctionEDate };
