/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { ErfUtils } from "./ErfUtils";
/**
 * @hidden
 */
var UltraCalcFunctionErfc = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionErfc, _super);
    function UltraCalcFunctionErfc() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionErfc.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.h(a, false, function (c) { return new ExcelCalcValue(ErfUtils.d(c)); });
    };
    UltraCalcFunctionErfc.prototype.get_name = function () {
        return "erfc";
    };
    Object.defineProperty(UltraCalcFunctionErfc.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErfc.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionErfc.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErfc.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionErfc.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErfc.$t = markType(UltraCalcFunctionErfc, 'UltraCalcFunctionErfc', BuiltInFunctionBase.$);
    return UltraCalcFunctionErfc;
}(BuiltInFunctionBase));
export { UltraCalcFunctionErfc };
