/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
/**
 * @hidden
 */
var UltraCalcFunctionFisherInv = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionFisherInv, _super);
    function UltraCalcFunctionFisherInv() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionFisherInv.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.h(a, true, function (c) { return new ExcelCalcValue(Math.tanh(c)); });
    };
    UltraCalcFunctionFisherInv.prototype.get_name = function () {
        return "fisherinv";
    };
    Object.defineProperty(UltraCalcFunctionFisherInv.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisherInv.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFisherInv.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisherInv.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionFisherInv.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionFisherInv.$t = markType(UltraCalcFunctionFisherInv, 'UltraCalcFunctionFisherInv', BuiltInFunctionBase.$);
    return UltraCalcFunctionFisherInv;
}(BuiltInFunctionBase));
export { UltraCalcFunctionFisherInv };
