/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { HyperlinkResult } from "./HyperlinkResult";
/**
 * @hidden
 */
var UltraCalcFunctionHyperlink = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionHyperlink, _super);
    function UltraCalcFunctionHyperlink() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionHyperlink.prototype.evaluate = function (a, b) {
        var c = null;
        if (b == 2) {
            c = a.pop();
        }
        var d = a.pop();
        if (d.isError) {
            return d;
        }
        if (c != null && c.isError) {
            return c;
        }
        var e = d.toString();
        var f = c == null ? e : c.toString();
        return new ExcelCalcValue(new HyperlinkResult(e, f));
    };
    UltraCalcFunctionHyperlink.prototype.get_name = function () {
        return "hyperlink";
    };
    Object.defineProperty(UltraCalcFunctionHyperlink.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionHyperlink.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionHyperlink.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionHyperlink.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionHyperlink.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionHyperlink.$t = markType(UltraCalcFunctionHyperlink, 'UltraCalcFunctionHyperlink', BuiltInFunctionBase.$);
    return UltraCalcFunctionHyperlink;
}(BuiltInFunctionBase));
export { UltraCalcFunctionHyperlink };
