/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { typeCast, markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionIfError = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIfError, _super);
    function UltraCalcFunctionIfError() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIfError.prototype.evaluate = function (a, b) {
        var c = a.pop();
        var d = a.pop();
        var e = d._getResolvedValue();
        if (typeCast(ExcelCalcErrorValue.$, e) !== null) {
            return c;
        }
        return new ExcelCalcValue(e);
    };
    UltraCalcFunctionIfError.prototype.get_name = function () {
        return "iferror";
    };
    Object.defineProperty(UltraCalcFunctionIfError.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfError.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionIfError.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfError.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionIfError.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIfError.$t = markType(UltraCalcFunctionIfError, 'UltraCalcFunctionIfError', BuiltInFunctionBase.$);
    return UltraCalcFunctionIfError;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIfError };
