/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { UltraCalcFunctionComplex_ComplexNumber } from "./UltraCalcFunctionComplex_ComplexNumber";
import { markType } from "igniteui-angular-core";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionImaginary = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionImaginary, _super);
    function UltraCalcFunctionImaginary() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionImaginary.prototype.evaluate = function (a, b) {
        var c = a.pop().toString();
        var d = new UltraCalcFunctionComplex_ComplexNumber(1, a._w, c);
        if (d.y == false) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        return new ExcelCalcValue(d.af);
    };
    UltraCalcFunctionImaginary.prototype.get_name = function () {
        return "imaginary";
    };
    Object.defineProperty(UltraCalcFunctionImaginary.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImaginary.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionImaginary.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImaginary.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionImaginary.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionImaginary.$t = markType(UltraCalcFunctionImaginary, 'UltraCalcFunctionImaginary', BuiltInFunctionBase.$);
    return UltraCalcFunctionImaginary;
}(BuiltInFunctionBase));
export { UltraCalcFunctionImaginary };
