/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionIsFormula = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIsFormula, _super);
    function UltraCalcFunctionIsFormula() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIsFormula.prototype.evaluate = function (a, b) {
        var c = a.pop();
        var d = false;
        if (c.isReference) {
            var e = c.toReference();
            var f = e.value;
            d = e.formula != null;
        }
        return new ExcelCalcValue(d);
    };
    UltraCalcFunctionIsFormula.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsFormula.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsFormula.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsFormula.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsFormula.prototype.get_name = function () {
        return "isformula";
    };
    Object.defineProperty(UltraCalcFunctionIsFormula.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsFormula.$t = markType(UltraCalcFunctionIsFormula, 'UltraCalcFunctionIsFormula', BuiltInFunctionBase.$);
    return UltraCalcFunctionIsFormula;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIsFormula };
