/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionIsText = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionIsText, _super);
    function UltraCalcFunctionIsText() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionIsText.prototype.evaluate = function (a, b) {
        var c = a.pop();
        return new ExcelCalcValue(c.isString);
    };
    UltraCalcFunctionIsText.prototype.get_name = function () {
        return "istext";
    };
    Object.defineProperty(UltraCalcFunctionIsText.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsText.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsText.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsText.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionIsText.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionIsText.$t = markType(UltraCalcFunctionIsText, 'UltraCalcFunctionIsText', BuiltInFunctionBase.$);
    return UltraCalcFunctionIsText;
}(BuiltInFunctionBase));
export { UltraCalcFunctionIsText };
