/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { UltraCalcFunctionTwoMatrixFunction } from "./UltraCalcFunctionTwoMatrixFunction";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionRsq = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRsq, _super);
    function UltraCalcFunctionRsq() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionRsq.prototype.evaluate = function (a, b) {
        var c;
        var d = ((function () { var e = UltraCalcFunctionTwoMatrixFunction._al(a, c); c = e.p1; return e.ret; })());
        if (c != null) {
            return new ExcelCalcValue(c);
        }
        return new ExcelCalcValue(d * d);
    };
    UltraCalcFunctionRsq.prototype.get_name = function () {
        return "rsq";
    };
    Object.defineProperty(UltraCalcFunctionRsq.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRsq.$t = markType(UltraCalcFunctionRsq, 'UltraCalcFunctionRsq', UltraCalcFunctionTwoMatrixFunction.$);
    return UltraCalcFunctionRsq;
}(UltraCalcFunctionTwoMatrixFunction));
export { UltraCalcFunctionRsq };
