/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { UltraCalcFunctionTwoMatrixFunction } from "./UltraCalcFunctionTwoMatrixFunction";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionSlope = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionSlope, _super);
    function UltraCalcFunctionSlope() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionSlope.prototype.evaluate = function (a, b) {
        var c;
        var d;
        var e;
        var f = UltraCalcFunctionTwoMatrixFunction._aq(a, d, e, c);
        d = f.p1;
        e = f.p2;
        c = f.p3;
        if (c != null) {
            return new ExcelCalcValue(c);
        }
        return new ExcelCalcValue(d);
    };
    UltraCalcFunctionSlope.prototype.get_name = function () {
        return "slope";
    };
    Object.defineProperty(UltraCalcFunctionSlope.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSlope.$t = markType(UltraCalcFunctionSlope, 'UltraCalcFunctionSlope', UltraCalcFunctionTwoMatrixFunction.$);
    return UltraCalcFunctionSlope;
}(UltraCalcFunctionTwoMatrixFunction));
export { UltraCalcFunctionSlope };
