/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { UltraCalcConditionalFunctionBase } from "./UltraCalcConditionalFunctionBase";
/**
 * @hidden
 */
var UltraCalcFunctionSumIfs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionSumIfs, _super);
    function UltraCalcFunctionSumIfs() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionSumIfs.prototype.evaluate = function (a, b) {
        return UltraCalcConditionalFunctionBase._ak(a, b, 0, function (c, d) { return new ExcelCalcValue(c); }, function (c, d) { return c + d; });
    };
    UltraCalcFunctionSumIfs.prototype.get_name = function () {
        return "sumifs";
    };
    Object.defineProperty(UltraCalcFunctionSumIfs.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumIfs.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionSumIfs.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumIfs.prototype.get_maxArgs = function () {
        return 0x7FFFFFFF;
    };
    Object.defineProperty(UltraCalcFunctionSumIfs.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionSumIfs.$t = markType(UltraCalcFunctionSumIfs, 'UltraCalcFunctionSumIfs', BuiltInFunctionBase.$);
    return UltraCalcFunctionSumIfs;
}(BuiltInFunctionBase));
export { UltraCalcFunctionSumIfs };
