import { Type } from "igniteui-angular-core";
/**
 * Specifies the group of the axis, i.e., whether it is a primary
 * or secondary axis.
 */
export declare enum AxisGroup {
    /**
     * Primary axis group.
     */
    Primary = 1,
    /**
     * Secondary axis group. Invalid for [[AxisType.seriesAxis]] in 3D charts
     */
    Secondary = 2
}
/**
 * @hidden
 */
export declare let AxisGroup_$type: Type;
