import { Type } from "igniteui-angular-core";
/**
 * Specifies the axis type.
 */
export declare enum AxisType {
    /**
     * Axis displays categories.
     */
    Category = 1,
    /**
     * Axis displays values.
     */
    Value = 2,
    /**
     * Axis displays data series along the Z-axis (3D charts only).
     */
    SeriesAxis = 3
}
/**
 * @hidden
 */
export declare let AxisType_$type: Type;
