import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { ST_DataValidationType } from "./ST_DataValidationType";
import { ST_DataValidationErrorStyle } from "./ST_DataValidationErrorStyle";
import { ST_DataValidationImeMode } from "./ST_DataValidationImeMode";
import { ST_DataValidationOperator } from "./ST_DataValidationOperator";
import { ST_Sqref } from "./ST_Sqref";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_DataValidation extends Base implements ISupportSetProperty {
    static $t: Type;
    constructor();
    p: string;
    q: string;
    m: Nullable$1<ST_DataValidationType>;
    g: Nullable$1<ST_DataValidationErrorStyle>;
    h: Nullable$1<ST_DataValidationImeMode>;
    i: Nullable$1<ST_DataValidationOperator>;
    f: Nullable$1<boolean>;
    j: Nullable$1<boolean>;
    l: Nullable$1<boolean>;
    k: Nullable$1<boolean>;
    o: string;
    n: string;
    s: string;
    r: string;
    a: ST_Sqref;
    static u(a: XmlPartManagerBase, b: Nullable$1<ST_DataValidationType>, c: Nullable$1<ST_DataValidationErrorStyle>, d: Nullable$1<ST_DataValidationImeMode>, e: Nullable$1<ST_DataValidationOperator>, f: Nullable$1<boolean>, g: Nullable$1<boolean>, h: Nullable$1<boolean>, i: Nullable$1<boolean>, j: string, k: string, l: string, m: string, n: ST_Sqref): {
        p1: Nullable$1<ST_DataValidationType>;
        p2: Nullable$1<ST_DataValidationErrorStyle>;
        p3: Nullable$1<ST_DataValidationImeMode>;
        p4: Nullable$1<ST_DataValidationOperator>;
        p5: Nullable$1<boolean>;
        p6: Nullable$1<boolean>;
        p7: Nullable$1<boolean>;
        p8: Nullable$1<boolean>;
        p9: string;
        p10: string;
        p11: string;
        p12: string;
        p13: ST_Sqref;
    };
    static v(a: XmlPartManagerBase, b: string, c: Nullable$1<ST_DataValidationOperator>, d: Nullable$1<boolean>, e: string, f: Nullable$1<ST_DataValidationErrorStyle>, g: string, h: Nullable$1<ST_DataValidationImeMode>, i: string, j: string, k: Nullable$1<boolean>, l: Nullable$1<boolean>, m: Nullable$1<boolean>, n: Nullable$1<ST_DataValidationType>, o: ST_Sqref): void;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
