import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_FontName } from "./CT_FontName";
import { CT_IntProperty } from "./CT_IntProperty";
import { CT_BooleanProperty } from "./CT_BooleanProperty";
import { ColorInfo } from "./ColorInfo";
import { CT_FontSize } from "./CT_FontSize";
import { CT_UnderlineProperty } from "./CT_UnderlineProperty";
import { CT_VerticalAlignFontProperty } from "./CT_VerticalAlignFontProperty";
import { CT_FontScheme_SML } from "./CT_FontScheme_SML";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_Font extends Base implements ISupportSetProperty {
    static $t: Type;
    constructor();
    i: CT_FontName;
    l: CT_IntProperty;
    m: CT_IntProperty;
    b: CT_BooleanProperty;
    e: CT_BooleanProperty;
    h: CT_BooleanProperty;
    f: CT_BooleanProperty;
    g: CT_BooleanProperty;
    c: CT_BooleanProperty;
    d: CT_BooleanProperty;
    a: ColorInfo;
    k: CT_FontSize;
    n: CT_UnderlineProperty;
    o: CT_VerticalAlignFontProperty;
    j: CT_FontScheme_SML;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
