import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_GraphicFrameNonVisual } from "./CT_GraphicFrameNonVisual";
import { CT_Transform2D } from "./CT_Transform2D";
import { CT_GraphicalObject } from "./CT_GraphicalObject";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_GraphicFrame extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private f;
    private d;
    private k;
    private i;
    constructor();
    get a(): CT_GraphicFrameNonVisual;
    set a(a: CT_GraphicFrameNonVisual);
    get e(): CT_Transform2D;
    set e(a: CT_Transform2D);
    get c(): CT_GraphicalObject;
    set c(a: CT_GraphicalObject);
    get j(): string;
    set j(a: string);
    get h(): Nullable$1<boolean>;
    set h(a: Nullable$1<boolean>);
    static m(a: XmlPartManagerBase, b: string, c: Nullable$1<boolean>): {
        p1: string;
        p2: Nullable$1<boolean>;
    };
    static n(a: XmlPartManagerBase, b: string, c?: Nullable$1<boolean>, d?: string): void;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
