import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ST_TextMargin } from "./ST_TextMargin";
import { ST_TextIndentLevelType } from "./ST_TextIndentLevelType";
import { ST_TextIndent } from "./ST_TextIndent";
import { ST_TextAlignType } from "./ST_TextAlignType";
import { ST_Coordinate32 } from "./ST_Coordinate32";
import { ST_TextFontAlignType } from "./ST_TextFontAlignType";
import { CT_TextCharacterPropertiesBase } from "./CT_TextCharacterPropertiesBase";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
/**
 * @hidden
 */
export declare class CT_TextParagraphProperties extends Base {
    static $t: Type;
    k: Nullable$1<ST_TextMargin>;
    l: Nullable$1<ST_TextMargin>;
    j: Nullable$1<ST_TextIndentLevelType>;
    h: Nullable$1<ST_TextIndent>;
    c: Nullable$1<ST_TextAlignType>;
    d: Nullable$1<ST_Coordinate32>;
    m: Nullable$1<boolean>;
    e: Nullable$1<boolean>;
    f: Nullable$1<ST_TextFontAlignType>;
    i: Nullable$1<boolean>;
    g: Nullable$1<boolean>;
    a: CT_TextCharacterPropertiesBase;
    static b(a: XmlPartManagerBase): CT_TextParagraphProperties;
}
