import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum CalcArgumentFlags {
    SkipEmptyReferences = 1,
    SkipHiddenRows = 2,
    IgnoreRefString = 4,
    IgnoreRefBoolean = 8,
    AdjustFor1904System = 16,
    TreatIndirectStringsAsZero = 32,
    IgnoreArrayBoolean = 64,
    TreatNullAsZero = 128,
    IgnoreErrors = 256,
    TreatErrorsAsZero = 512,
    IgnoreArrayString = 1024,
    SkipSubtotals = 2048,
    SkipHiddenColumns = 4096,
    SkipHiddenCells = 4098,
    Normal = 1229,
    NormalA = 1249,
    Count = 1485,
    CountA = 673,
    EnumerableNumericOnlyFlags = 1101
}
/**
 * @hidden
 */
export declare let CalcArgumentFlags_$type: Type;
