import { Type } from "igniteui-angular-core";
/**
 * Constants which define the type of a category axis.
 */
export declare enum CategoryType {
    /**
     * Scale is determined automatically.
     */
    AutomaticScale = -4105,
    /**
     * A category [[Axis]].
     */
    CategoryScale = 2,
    /**
     * A date/time [[Axis]].
     */
    TimeScale = 3
}
/**
 * @hidden
 */
export declare let CategoryType_$type: Type;
