import { Type } from "igniteui-angular-core";
/**
 * Constants which specify the manner in which the color for negative-value
 * data bars is determined.
 */
export declare enum DataBarNegativeBarColorType {
    /**
     * Use the value of the [[NegativeBarFormat.barColor]] property.
     */
    Color = 0,
    /**
     * Use the same color as that of the positive-value data bars.
     */
    SameAsPositive = 1
}
/**
 * @hidden
 */
export declare let DataBarNegativeBarColorType_$type: Type;
