import { InvalidOperationException } from "igniteui-angular-core";
import { BaseError, Type } from "igniteui-angular-core";
/**
 * Represents an error that occurs when no password is used to open an encrypted document.
 */
export declare class DocumentEncryptedException extends InvalidOperationException {
    static $t: Type;
    constructor();
    constructor(message: string);
    constructor(message: string, innerException: BaseError);
    constructor(..._rest: any[]);
}
