import { Base, Type } from "igniteui-angular-core";
import { AlignmentInfo } from "./AlignmentInfo";
import { BorderInfo } from "./BorderInfo";
import { FillInfo } from "./FillInfo";
import { IWorkbookFont } from "./IWorkbookFont";
import { ColorInfo } from "./ColorInfo";
import { SerializationNumberFormatInfo } from "./SerializationNumberFormatInfo";
import { ProtectionInfo } from "./ProtectionInfo";
import { WorkbookSaveManager } from "./WorkbookSaveManager";
import { WorksheetCellFormatData } from "./WorksheetCellFormatData";
import { WorkbookLoadManager } from "./WorkbookLoadManager";
/**
 * @hidden
 */
export declare class DxfInfo extends Base {
    static $t: Type;
    constructor(a: number);
    constructor(a: number, b: WorkbookSaveManager, c: WorksheetCellFormatData);
    constructor(a: number, ..._rest: any[]);
    h(a: WorkbookLoadManager): WorksheetCellFormatData;
    b: AlignmentInfo;
    c: BorderInfo;
    e: FillInfo;
    a: IWorkbookFont;
    d: ColorInfo;
    g: SerializationNumberFormatInfo;
    f: ProtectionInfo;
}
