import { Type } from "igniteui-angular-core";
/**
 * Identifies the set of icons used by a [[IconCriterion]].
 * @see [[IconCriterion.icon]]
 */
export declare enum FormatConditionIcon {
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenUpArrow = 1
     */
    GreenUpArrow = 1,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowSideArrow = 2
     */
    YellowSideArrow = 2,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedDownArrow = 3
     */
    RedDownArrow = 3,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGrayUpArrow = 4
     */
    GrayUpArrow = 4,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGraySideArrow = 5
     */
    GraySideArrow = 5,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGrayDownArrow = 6
     */
    GrayDownArrow = 6,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenFlag = 7
     */
    GreenFlag = 7,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowFlag = 8
     */
    YellowFlag = 8,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedFlag = 9
     */
    RedFlag = 9,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenCircle = 10
     */
    GreenCircle = 10,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowCircle = 11
     */
    YellowCircle = 11,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedCircleWithBorder = 12
     */
    RedCircleWithBorder = 12,
    /**
     * Microsoft.Office.Interop.Excel.xlIconBlackCircleWithBorder = 13
     */
    BlackCircleWithBorder = 13,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenTrafficLight = 14
     */
    GreenTrafficLight = 14,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowTrafficLight = 15
     */
    YellowTrafficLight = 15,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedTrafficLight = 16
     */
    RedTrafficLight = 16,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowTriangle = 17
     */
    YellowTriangle = 17,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedDiamond = 18
     */
    RedDiamond = 18,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenCheckSymbol = 19
     */
    GreenCheckSymbol = 19,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowExclamationSymbol = 20
     */
    YellowExclamationSymbol = 20,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedCrossSymbol = 21
     */
    RedCrossSymbol = 21,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenCheck = 22
     */
    GreenCheck = 22,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowExclamation = 23
     */
    YellowExclamation = 23,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedCross = 24
     */
    RedCross = 24,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowUpInclineArrow = 25
     */
    YellowUpInclineArrow = 25,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowDownInclineArrow = 26
     */
    YellowDownInclineArrow = 26,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGrayUpInclineArrow = 27
     */
    GrayUpInclineArrow = 27,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGrayDownInclineArrow = 28
     */
    GrayDownInclineArrow = 28,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedCircle = 29
     */
    RedCircle = 29,
    /**
     * Microsoft.Office.Interop.Excel.xlIconPinkCircle = 30
     */
    PinkCircle = 30,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGrayCircle = 31
     */
    GrayCircle = 31,
    /**
     * Microsoft.Office.Interop.Excel.xlIconBlackCircle = 32
     */
    BlackCircle = 32,
    /**
     * Microsoft.Office.Interop.Excel.xlIconCircleWithOneWhiteQuarter = 33
     */
    CircleWithOneWhiteQuarter = 33,
    /**
     * Microsoft.Office.Interop.Excel.xlIconCircleWithTwoWhiteQuarters = 34
     */
    CircleWithTwoWhiteQuarters = 34,
    /**
     * Microsoft.Office.Interop.Excel.xlIconCircleWithThreeWhiteQuarters = 35
     */
    CircleWithThreeWhiteQuarters = 35,
    /**
     * Microsoft.Office.Interop.Excel.xlIconWhiteCircleAllWhiteQuarters = 36
     */
    WhiteCircleAllWhiteQuarters = 36,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon0Bars = 37
     */
    ZeroBars = 37,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon1Bar = 38
     */
    OneBar = 38,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon2Bars = 39
     */
    TwoBars = 39,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon3Bars = 40
     */
    ThreeBars = 40,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon4Bars = 41
     */
    FourBars = 41,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGoldStar = 42
     */
    GoldStar = 42,
    /**
     * Microsoft.Office.Interop.Excel.xlIconHalfGoldStar = 43
     */
    HalfGoldStar = 43,
    /**
     * Microsoft.Office.Interop.Excel.xlIconSilverStar = 44
     */
    SilverStar = 44,
    /**
     * Microsoft.Office.Interop.Excel.xlIconGreenUpTriangle = 45
     */
    GreenUpTriangle = 45,
    /**
     * Microsoft.Office.Interop.Excel.xlIconYellowDash = 46
     */
    YellowDash = 46,
    /**
     * Microsoft.Office.Interop.Excel.xlIconRedDownTriangle = 47
     */
    RedDownTriangle = 47,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon4FilledBoxes = 48
     */
    FourFilledBoxes = 48,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon3FilledBoxes = 49
     */
    ThreeFilledBoxes = 49,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon2FilledBoxes = 50
     */
    TwoFilledBoxes = 50,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon1FilledBox = 51
     */
    OneFilledBox = 51,
    /**
     * Microsoft.Office.Interop.Excel.xlIcon0FilledBoxes = 52
     */
    ZeroFilledBoxes = 52,
    /**
     * Microsoft.Office.Interop.Excel.xlIconNoCellIcon = -1
     */
    NoCellIcon = -1
}
/**
 * @hidden
 */
export declare let FormatConditionIcon_$type: Type;
