import { Type } from "igniteui-angular-core";
/**
 * Constans which identify whether a [[RankConditionalFormat]] evaluates
 * to true for the top or bottom ranked values across the associated range.
 */
export declare enum FormatConditionTopBottom {
    /**
     * The cell value must fall within the bottom ranking of values for the associated range.
     */
    Bottom = 0,
    /**
     * The cell value must fall within the top ranking of values for the associated range.
     */
    Top = 1
}
/**
 * @hidden
 */
export declare let FormatConditionTopBottom_$type: Type;
