import { ArgumentException } from "igniteui-angular-core";
import { BaseError, Type } from "igniteui-angular-core";
/**
 * Introduce InvalidEnumArgumentException class to Silverlight
 */
export declare class InvalidEnumArgumentException extends ArgumentException {
    static $t: Type;
    constructor(message?: string, innerException?: BaseError);
    constructor(message: string, paramName: string);
    constructor(argumentName: string, invalidValue: number, enumClass: Type);
    constructor(..._rest: any[]);
}
