import { Base, IEnumerable$1, Type } from "igniteui-angular-core";
import { IPackage } from "./IPackage";
import { IPackagePart } from "./IPackagePart";
import { Uri } from "igniteui-angular-core";
import { IPackageRelationship } from "./IPackageRelationship";
import { RelationshipTargetMode } from "./RelationshipTargetMode";
/**
 * @hidden
 */
export declare class InvalidPackage extends Base implements IPackage {
    static $t: Type;
    createPart(a: Uri, b: string): IPackagePart;
    createRelationship(a: Uri, b: RelationshipTargetMode, c: string, d: string): IPackageRelationship;
    dispose(): void;
    getPart(a: Uri): IPackagePart;
    getParts(): IEnumerable$1<IPackagePart>;
    getRelationship(a: string): IPackageRelationship;
    getRelationships(): IEnumerable$1<IPackageRelationship>;
    partExists(a: Uri): boolean;
}
