import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { CellBorderLineStyle } from "./CellBorderLineStyle";
import { DiagonalBorders } from "./DiagonalBorders";
import { FontSuperscriptSubscriptStyle } from "./FontSuperscriptSubscriptStyle";
import { FontUnderlineStyle } from "./FontUnderlineStyle";
import { HorizontalCellAlignment } from "./HorizontalCellAlignment";
import { ST_CellType } from "./ST_CellType";
import { VerticalCellAlignment } from "./VerticalCellAlignment";
import { Dictionary$2 } from "igniteui-angular-core";
import { WorksheetCellFormatOptions } from "./WorksheetCellFormatOptions";
/**
 * @hidden
 */
export declare class KnownBoxes extends Base {
    static $t: Type;
    static readonly w: any;
    static readonly x: any;
    static readonly f: any;
    static readonly n: any;
    static readonly c: any;
    static readonly d: any;
    static readonly e: any;
    static readonly g: any;
    static readonly h: any;
    static readonly i: any;
    static readonly j: any;
    static readonly k: any;
    static readonly l: any;
    static readonly m: any;
    static readonly o: any;
    static readonly p: any;
    static readonly q: any;
    static al(a: CellBorderLineStyle): any;
    static readonly s: any;
    static readonly r: any;
    static readonly t: any;
    static readonly u: any;
    static readonly v: any;
    static am(a: DiagonalBorders): any;
    static readonly y: any;
    static readonly z: any;
    static readonly aa: any;
    static au(a: Nullable$1<boolean>): any;
    static readonly ab: any;
    static readonly ac: any;
    static readonly ad: any;
    static readonly ae: any;
    static an(a: FontSuperscriptSubscriptStyle): any;
    static readonly af: any;
    static readonly ai: any;
    static readonly ag: any;
    static readonly ah: any;
    static readonly aj: any;
    static readonly ak: any;
    static ao(a: FontUnderlineStyle): any;
    static readonly ax: any;
    static readonly a0: any;
    static readonly av: any;
    static readonly aw: any;
    static readonly ay: any;
    static readonly az: any;
    static readonly a1: any;
    static readonly a2: any;
    static readonly a3: any;
    static ap(a: HorizontalCellAlignment): any;
    static readonly a4: any;
    static readonly a5: any;
    static at(a: number): any;
    static readonly a6: any;
    static readonly a7: any;
    static readonly ba: any;
    static readonly a8: any;
    static readonly bb: any;
    static readonly bc: any;
    static readonly a9: any;
    static as(a: ST_CellType): any;
    static readonly bf: any;
    static readonly bd: any;
    static readonly be: any;
    static readonly bg: any;
    static readonly bh: any;
    static readonly bi: any;
    static aq(a: VerticalCellAlignment): any;
    static readonly a: Dictionary$2<number, any>;
    private static b;
    static ar(a: WorksheetCellFormatOptions): any;
}
