import { SortCondition } from "./SortCondition";
import { ST_SortBy } from "./ST_SortBy";
import { SortDirection } from "./SortDirection";
import { ISortable } from "./ISortable";
import { SortSettings_SortOperation$1 } from "./SortSettings_SortOperation$1";
import { Worksheet } from "./Worksheet";
import { Type } from "igniteui-angular-core";
import { SortSettings$1 } from "./SortSettings$1";
/**
 * Represents an ordered sort condition, which can sort data in either an ascending or descending manner.
 * @see [[SortSettings`1.sortConditions]]
 */
export declare class OrderedSortCondition extends SortCondition {
    static $t: Type;
    constructor();
    constructor(sortDirection: SortDirection);
    constructor(..._rest: any[]);
    /**
     * @hidden
     */
    _a(): SortCondition;
    /**
     * @hidden
     */
    _g<T extends ISortable>($t: Type, a: SortSettings_SortOperation$1<T>, b: number, c: number, d: number, e: number): number;
    /**
     * @hidden
     */
    _f(a: SortCondition): boolean;
    /**
     * @hidden
     */
    protected get__d(): ST_SortBy;
    /**
     * @hidden
     */
    get _d(): ST_SortBy;
    /**
     * @hidden
     */
    static _i<T extends ISortable>($t: Type, a: SortSettings$1<T>, b: Worksheet, c: any, d: any): number;
}
