import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ColorInfo } from "./ColorInfo";
import { FillPatternStyle } from "./FillPatternStyle";
import { WorkbookSaveManager } from "./WorkbookSaveManager";
import { WorksheetCellFormatData } from "./WorksheetCellFormatData";
import { CellFillPattern } from "./CellFillPattern";
import { WorkbookLoadManager } from "./WorkbookLoadManager";
/**
 * @hidden
 */
export declare class PatternFillInfo extends Base {
    static $t: Type;
    private c;
    private d;
    private i;
    equals(a: any): boolean;
    getHashCode(): number;
    get b(): ColorInfo;
    set b(a: ColorInfo);
    get e(): ColorInfo;
    set e(a: ColorInfo);
    get j(): Nullable$1<FillPatternStyle>;
    set j(a: Nullable$1<FillPatternStyle>);
    static f(a: WorkbookSaveManager, b: WorksheetCellFormatData, c: CellFillPattern): PatternFillInfo;
    a(a: WorkbookLoadManager, b: WorksheetCellFormatData): CellFillPattern;
}
