import { Type } from "igniteui-angular-core";
/**
 * Indicates the type of workbook [[Sheet]]
 */
export declare enum SheetType {
    /**
     * A sheet that contains rows and columns of data.
     */
    Worksheet = 0,
    /**
     * A sheet that displays a single [[WorksheetChart]]
     */
    Chartsheet = 1
}
/**
 * @hidden
 */
export declare let SheetType_$type: Type;
