import { Type } from "igniteui-angular-core";
/**
 * Determines the alignment for axis [[Axis.tickLabels]]
 */
export declare enum TickLabelAlignment {
    /**
     * The tick labels will be aligned on the left
     */
    Left = -4131,
    /**
     * The tick labels will be centered
     */
    Center = -4108,
    /**
     * The tick labels will be aligned on the right
     */
    Right = -4152
}
/**
 * @hidden
 */
export declare let TickLabelAlignment_$type: Type;
