import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcNumberStack } from "./ExcelCalcNumberStack";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare abstract class UltraCalcFunctionTwoMatrixFunction extends BuiltInFunctionBase {
    static $t: Type;
    protected _ak(a: ExcelCalcNumberStack, b: (element1: number, element2: number) => number): ExcelCalcValue;
    protected static _al(a: ExcelCalcNumberStack, b: ExcelCalcErrorValue): {
        ret: number;
        p1: ExcelCalcErrorValue;
    };
    protected static _ao(a: ExcelCalcNumberStack, b: ExcelCalcErrorValue, c: number[][], d: number[][]): {
        p1: ExcelCalcErrorValue;
        p2: number[][];
        p3: number[][];
    };
    protected static _aq(a: ExcelCalcNumberStack, b: number, c: number, d: ExcelCalcErrorValue): {
        p1: number;
        p2: number;
        p3: ExcelCalcErrorValue;
    };
    protected static _ap(a: number[][], b: number[][], c: number, d: number, e: number, f: number, g: ExcelCalcErrorValue): {
        p2: number;
        p3: number;
        p4: number;
        p5: number;
        p6: ExcelCalcErrorValue;
    };
    protected static _ar(a: number[][], b: number[][], c: number, d: number, e: number): {
        p2: number;
        p3: number;
        p4: number;
    };
    protected static _an(a: number[][], b: (element1: number) => number): number;
    protected static _am(a: number[][], b: number[][], c: (element1: number, element2: number) => number): number;
    protected get_minArgs(): number;
    get minArgs(): number;
    protected get_maxArgs(): number;
    get maxArgs(): number;
}
