import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum WorksheetPermissions {
    None = 0,
    SelectLockedCells = 1,
    SelectUnlockedCells = 2,
    FormatCells = 4,
    FormatColumns = 8,
    FormatRows = 16,
    InsertColumns = 32,
    InsertRows = 64,
    InsertHyperlinks = 128,
    DeleteColumns = 256,
    DeleteRows = 512,
    Sort = 1024,
    Filter = 2048,
    PivotTable = 4096,
    EditObjects = 8192,
    EditScenarios = 16384,
    All = -1
}
/**
 * @hidden
 */
export declare let WorksheetPermissions_$type: Type;
