/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, typeCast, markType, getInstanceType } from "igniteui-angular-core";
import { ISupportSetProperty_$type } from "./ISupportSetProperty";
import { CT_ExtremeValueColorPosition } from "./CT_ExtremeValueColorPosition";
import { CT_NumberColorPosition } from "./CT_NumberColorPosition";
import { CT_PercentageColorPosition } from "./CT_PercentageColorPosition";
/**
 * @hidden
 */
export let CT_ValueColorEndPosition = /*@__PURE__*/ (() => {
    class CT_ValueColorEndPosition extends Base {
        constructor() {
            super(...arguments);
            this.a = null;
            this.b = null;
            this.c = null;
        }
        setProperty(a, b) {
            switch (a) {
                case 1914:
                    this.a = typeCast(CT_ExtremeValueColorPosition.$, b);
                    break;
                case 1912:
                    this.b = typeCast(CT_NumberColorPosition.$, b);
                    break;
                case 1913:
                    this.c = typeCast(CT_PercentageColorPosition.$, b);
                    break;
                default: break;
            }
        }
        toString() {
            let a = getInstanceType(this);
            return a != null ? a.typeName : super.toString();
        }
    }
    CT_ValueColorEndPosition.$t = markType(CT_ValueColorEndPosition, 'CT_ValueColorEndPosition', Base.$, [ISupportSetProperty_$type]);
    return CT_ValueColorEndPosition;
})();
