/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which identify the threshold of a [[ColorScaleCriterion]].
 */
export var ColorScaleCriterionThreshold = /*@__PURE__*/ (function (ColorScaleCriterionThreshold) {
    /**
     * Identifies the minimum threshold.
     */
    ColorScaleCriterionThreshold[ColorScaleCriterionThreshold["Minimum"] = 0] = "Minimum";
    /**
     * Identifies the midpoint threshold.
     */
    ColorScaleCriterionThreshold[ColorScaleCriterionThreshold["Midpoint"] = 1] = "Midpoint";
    /**
     * Identifies the maximum threshold.
     */
    ColorScaleCriterionThreshold[ColorScaleCriterionThreshold["Maximum"] = 2] = "Maximum";
    return ColorScaleCriterionThreshold;
})({});
/**
 * @hidden
 */
export let ColorScaleCriterionThreshold_$type = markEnum('ColorScaleCriterionThreshold', 'Minimum,0|Midpoint,1|Maximum,2');
