/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, markType } from "igniteui-angular-core";
import { IComparer$1_$type } from "igniteui-angular-core";
import { ConditionPriority } from "./ConditionPriority";
/**
 * @hidden
 */
export let ConditionPrioritySortComparer = /*@__PURE__*/ (() => {
    class ConditionPrioritySortComparer extends Base {
        compare(a, b) {
            if (a == null || b == null) {
                return 0;
            }
            return Base.compareSimple(a.b, b.b);
        }
    }
    ConditionPrioritySortComparer.$t = markType(ConditionPrioritySortComparer, 'ConditionPrioritySortComparer', Base.$, [IComparer$1_$type.specialize(ConditionPriority.$)]);
    return ConditionPrioritySortComparer;
})();
