/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which specify the manner in which the color for negative-value
 * data bars is determined.
 */
export var DataBarNegativeBarColorType = /*@__PURE__*/ (function (DataBarNegativeBarColorType) {
    /**
     * Use the value of the [[NegativeBarFormat.barColor]] property.
     */
    DataBarNegativeBarColorType[DataBarNegativeBarColorType["Color"] = 0] = "Color";
    /**
     * Use the same color as that of the positive-value data bars.
     */
    DataBarNegativeBarColorType[DataBarNegativeBarColorType["SameAsPositive"] = 1] = "SameAsPositive";
    return DataBarNegativeBarColorType;
})({});
/**
 * @hidden
 */
export let DataBarNegativeBarColorType_$type = markEnum('DataBarNegativeBarColorType', 'Color,0|SameAsPositive,1');
