/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various ways a date can be stored internally.
 */
export var DateSystem = /*@__PURE__*/ (function (DateSystem) {
    /**
     * Dates are stored as time elapsed since 1900.
     */
    DateSystem[DateSystem["From1900"] = 0] = "From1900";
    /**
     * Dates are stored as time elapsed since 1904 (used mainly on Apple computers).
     */
    DateSystem[DateSystem["From1904"] = 1] = "From1904";
    return DateSystem;
})({});
/**
 * @hidden
 */
export let DateSystem_$type = markEnum('DateSystem', 'From1900,0|From1904,1');
