/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ImagePartManagerBase } from "./ImagePartManagerBase";
import { ImageFormat } from "./ImageFormat";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let EmfPartManager = /*@__PURE__*/ (() => {
    class EmfPartManager extends ImagePartManagerBase {
        constructor() {
            super();
        }
        get_s() {
            return "/xl/media/image.emf";
        }
        get s() {
            return this.get_s();
        }
        get_t() {
            return "/ppt/media/image.emf";
        }
        get t() {
            return this.get_t();
        }
        get_u() {
            return "/word/media/image.emf";
        }
        get u() {
            return this.get_u();
        }
        get_m() {
            return "image/x-emf";
        }
        get m() {
            return this.get_m();
        }
        r(a) {
            return ImageFormat.c;
        }
    }
    EmfPartManager.$t = markType(EmfPartManager, 'EmfPartManager', ImagePartManagerBase.$);
    EmfPartManager.y = new EmfPartManager();
    return EmfPartManager;
})();
