/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { IOException } from "./IOException";
import { markType } from "igniteui-angular-core";
/**
 * Represents an error in which an attempt was made to read past the end of a stream of data.
 */
export let EndOfStreamException = /*@__PURE__*/ (() => {
    class EndOfStreamException extends IOException {
        constructor(message, innerException) {
            super(message, innerException);
            message = (message !== void 0 ? message : null);
            innerException = (innerException !== void 0 ? innerException : null);
        }
    }
    EndOfStreamException.$t = markType(EndOfStreamException, 'EndOfStreamException', IOException.$);
    return EndOfStreamException;
})();
