/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which identify a set of icons for an [[IconSetConditionalFormat]].
 */
export var FormatConditionIconSet = /*@__PURE__*/ (function (FormatConditionIconSet) {
    /**
     * No icon is shown.
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSetNoIcon"] = -1] = "IconSetNoIcon";
    /**
     * Microsoft.Office.Interop.Excel.xl3Arrows = 1
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Arrows"] = 1] = "IconSet3Arrows";
    /**
     * Microsoft.Office.Interop.Excel.xl3ArrowsGray = 2
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3ArrowsGray"] = 2] = "IconSet3ArrowsGray";
    /**
     * Microsoft.Office.Interop.Excel.xl3Flags = 3
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Flags"] = 3] = "IconSet3Flags";
    /**
     * Microsoft.Office.Interop.Excel.xl3TrafficLights1 = 4
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3TrafficLights1"] = 4] = "IconSet3TrafficLights1";
    /**
     * Microsoft.Office.Interop.Excel.xl3TrafficLights2 = 5
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3TrafficLights2"] = 5] = "IconSet3TrafficLights2";
    /**
     * Microsoft.Office.Interop.Excel.xl3Signs = 6
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Signs"] = 6] = "IconSet3Signs";
    /**
     * Microsoft.Office.Interop.Excel.xl3Symbols = 7
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Symbols"] = 7] = "IconSet3Symbols";
    /**
     * Microsoft.Office.Interop.Excel.xl3Symbols2 = 8
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Symbols2"] = 8] = "IconSet3Symbols2";
    /**
     * Microsoft.Office.Interop.Excel.xl4Arrows = 9
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet4Arrows"] = 9] = "IconSet4Arrows";
    /**
     * Microsoft.Office.Interop.Excel.xl4ArrowsGray = 10
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet4ArrowsGray"] = 10] = "IconSet4ArrowsGray";
    /**
     * Microsoft.Office.Interop.Excel.xl4RedToBlack = 11
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet4RedToBlack"] = 11] = "IconSet4RedToBlack";
    /**
     * Microsoft.Office.Interop.Excel.xl4CRV = 12
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet4Rating"] = 12] = "IconSet4Rating";
    /**
     * Microsoft.Office.Interop.Excel.xl4TrafficLights = 13
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet4TrafficLights"] = 13] = "IconSet4TrafficLights";
    /**
     * Microsoft.Office.Interop.Excel.xl5Arrows = 14
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet5Arrows"] = 14] = "IconSet5Arrows";
    /**
     * Microsoft.Office.Interop.Excel.xl5ArrowsGray = 15
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet5ArrowsGray"] = 15] = "IconSet5ArrowsGray";
    /**
     * Microsoft.Office.Interop.Excel.xl5CRV = 16
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet5Rating"] = 16] = "IconSet5Rating";
    /**
     * Microsoft.Office.Interop.Excel.xl5Quarters = 17
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet5Quarters"] = 17] = "IconSet5Quarters";
    /**
     * Microsoft.Office.Interop.Excel.xl3Stars = 18
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Stars"] = 18] = "IconSet3Stars";
    /**
     * Microsoft.Office.Interop.Excel.xl3Triangles = 19
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet3Triangles"] = 19] = "IconSet3Triangles";
    /**
     * Microsoft.Office.Interop.Excel.xl5Boxes = 20
     */
    FormatConditionIconSet[FormatConditionIconSet["IconSet5Boxes"] = 20] = "IconSet5Boxes";
    return FormatConditionIconSet;
})({});
/**
 * @hidden
 */
export let FormatConditionIconSet_$type = markEnum('FormatConditionIconSet', 'IconSetNoIcon,-1|IconSet3Arrows,1|IconSet3ArrowsGray,2|IconSet3Flags,3|IconSet3TrafficLights1,4|IconSet3TrafficLights2,5|IconSet3Signs,6|IconSet3Symbols,7|IconSet3Symbols2,8|IconSet4Arrows,9|IconSet4ArrowsGray,10|IconSet4RedToBlack,11|IconSet4Rating,12|IconSet4TrafficLights,13|IconSet5Arrows,14|IconSet5ArrowsGray,15|IconSet5Rating,16|IconSet5Quarters,17|IconSet3Stars,18|IconSet3Triangles,19|IconSet5Boxes,20');
