/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { SystemException, markType } from "igniteui-angular-core";
/**
 * Represents an error in which an attempt was made to treat a value as the wrong type.
 */
export let InvalidCastException = /*@__PURE__*/ (() => {
    class InvalidCastException extends SystemException {
        constructor(message, innerException) {
            super(2, message, innerException);
            message = (message !== void 0 ? message : null);
            innerException = (innerException !== void 0 ? innerException : null);
        }
    }
    InvalidCastException.$t = markType(InvalidCastException, 'InvalidCastException', SystemException.$);
    return InvalidCastException;
})();
