/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various way objects and shapes are displayed in the workbook.
 */
export var ObjectDisplayStyle = /*@__PURE__*/ (function (ObjectDisplayStyle) {
    /**
     * All object are be shown.
     */
    ObjectDisplayStyle[ObjectDisplayStyle["ShowAll"] = 0] = "ShowAll";
    /**
     * Placeholders are shown in place of objects.
     */
    ObjectDisplayStyle[ObjectDisplayStyle["ShowPlaceholders"] = 1] = "ShowPlaceholders";
    /**
     * No objects or shapes are shown.
     */
    ObjectDisplayStyle[ObjectDisplayStyle["HideAll"] = 2] = "HideAll";
    return ObjectDisplayStyle;
})({});
/**
 * @hidden
 */
export let ObjectDisplayStyle_$type = markEnum('ObjectDisplayStyle', 'ShowAll,0|ShowPlaceholders,1|HideAll,2');
