/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Indicates the type of workbook [[Sheet]]
 */
export var SheetType = /*@__PURE__*/ (function (SheetType) {
    /**
     * A sheet that contains rows and columns of data.
     */
    SheetType[SheetType["Worksheet"] = 0] = "Worksheet";
    /**
     * A sheet that displays a single [[WorksheetChart]]
     */
    SheetType[SheetType["Chartsheet"] = 1] = "Chartsheet";
    return SheetType;
})({});
/**
 * @hidden
 */
export let SheetType_$type = markEnum('SheetType', 'Worksheet,0|Chartsheet,1');
