/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Determines how blanks are displayed in a sparkline
 * @see [[SparklineGroup.displayBlanksAs]]
 */
export var SparklineDisplayBlanksAs = /*@__PURE__*/ (function (SparklineDisplayBlanksAs) {
    /**
     * Empty cells are plotted as interpolated.
     */
    SparklineDisplayBlanksAs[SparklineDisplayBlanksAs["Span"] = 0] = "Span";
    /**
     * Empty cells are not plotted.
     */
    SparklineDisplayBlanksAs[SparklineDisplayBlanksAs["Gap"] = 1] = "Gap";
    /**
     * Empty cells are plotted as zero.
     */
    SparklineDisplayBlanksAs[SparklineDisplayBlanksAs["Zero"] = 2] = "Zero";
    return SparklineDisplayBlanksAs;
})({});
/**
 * @hidden
 */
export let SparklineDisplayBlanksAs_$type = markEnum('SparklineDisplayBlanksAs', 'Span,0|Gap,1|Zero,2');
