/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { UltraCalcFunctionTwoMatrixFunction } from "./UltraCalcFunctionTwoMatrixFunction";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let UltraCalcFunctionCorrel = /*@__PURE__*/ (() => {
    class UltraCalcFunctionCorrel extends UltraCalcFunctionTwoMatrixFunction {
        evaluate(a, b) {
            let c;
            let d;
            let e;
            let f = UltraCalcFunctionTwoMatrixFunction._ao(a, c, d, e);
            c = f.p1;
            d = f.p2;
            e = f.p3;
            if (c != null) {
                return new ExcelCalcValue(c);
            }
            let g;
            let h;
            let i;
            let j = UltraCalcFunctionTwoMatrixFunction._ar(d, e, g, h, i);
            g = j.p2;
            h = j.p3;
            i = j.p4;
            let k = (l) => l * l;
            let l = UltraCalcFunctionTwoMatrixFunction._an(d, k);
            let m = UltraCalcFunctionTwoMatrixFunction._an(e, k);
            let n = l - ((h * h) / g);
            let o = m - ((i * i) / g);
            let p = UltraCalcFunctionTwoMatrixFunction._am(d, e, (q, r) => q * r);
            let q = p - ((h * i) / g);
            if (n == 0 || o == 0) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(2));
            }
            let r = q / (Math.sqrt(n) * Math.sqrt(o));
            return new ExcelCalcValue(r);
        }
        get_name() {
            return "correl";
        }
        get name() {
            return this.get_name();
        }
    }
    UltraCalcFunctionCorrel.$t = markType(UltraCalcFunctionCorrel, 'UltraCalcFunctionCorrel', UltraCalcFunctionTwoMatrixFunction.$);
    return UltraCalcFunctionCorrel;
})();
