/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
export let UltraCalcFunctionPower = /*@__PURE__*/ (() => {
    class UltraCalcFunctionPower extends BuiltInFunctionBase {
        evaluate(a, b) {
            let c = a.pop();
            let d = a.pop();
            if (d.isError) {
                return new ExcelCalcValue(d.toErrorValue());
            }
            if (c.isError) {
                return new ExcelCalcValue(c.toErrorValue());
            }
            let e, f;
            if (!((() => { let g = c._toDouble1(f); f = g.p0; return g.ret; })()) || !((() => { let g = d._toDouble1(e); e = g.p0; return g.ret; })())) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(1));
            }
            if (true && e == 0) {
                if (f == 0) {
                    return new ExcelCalcValue(new ExcelCalcErrorValue(4));
                }
                else if (f < 0) {
                    return new ExcelCalcValue(new ExcelCalcErrorValue(2));
                }
            }
            return new ExcelCalcValue(Math.pow(e, f));
        }
        get_name() {
            return "power";
        }
        get name() {
            return this.get_name();
        }
        get_minArgs() {
            return 2;
        }
        get minArgs() {
            return this.get_minArgs();
        }
        get_maxArgs() {
            return 2;
        }
        get maxArgs() {
            return this.get_maxArgs();
        }
    }
    UltraCalcFunctionPower.$t = markType(UltraCalcFunctionPower, 'UltraCalcFunctionPower', BuiltInFunctionBase.$);
    return UltraCalcFunctionPower;
})();
