/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { UltraCalcFunctionStDevBase } from "./UltraCalcFunctionStDevBase";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { UltraCalcFunctionStdev } from "./UltraCalcFunctionStdev";
/**
 * @hidden
 */
export let UltraCalcFunctionStDev_S = /*@__PURE__*/ (() => {
    class UltraCalcFunctionStDev_S extends UltraCalcFunctionStDevBase {
        evaluate(a, b) {
            return CalcFunctionUtilities.d(a, b, 1229, (c) => UltraCalcFunctionStdev._al(c, true));
        }
        get_name() {
            return "stdev.s";
        }
        get name() {
            return this.get_name();
        }
    }
    UltraCalcFunctionStDev_S.$t = markType(UltraCalcFunctionStDev_S, 'UltraCalcFunctionStDev_S', UltraCalcFunctionStDevBase.$);
    return UltraCalcFunctionStDev_S;
})();
