/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various vertical text alignment types.
 */
export var VerticalTextAlignment = /*@__PURE__*/ (function (VerticalTextAlignment) {
    /**
     * Align the text to the bottom of the available area.
     */
    VerticalTextAlignment[VerticalTextAlignment["Bottom"] = 0] = "Bottom";
    /**
     * Align the center to the bottom of the available area.
     */
    VerticalTextAlignment[VerticalTextAlignment["Center"] = 1] = "Center";
    /**
     * Align the text to the top of the available area.
     */
    VerticalTextAlignment[VerticalTextAlignment["Top"] = 2] = "Top";
    return VerticalTextAlignment;
})({});
/**
 * @hidden
 */
export let VerticalTextAlignment_$type = markEnum('VerticalTextAlignment', 'Bottom,0|Center,1|Top,2');
