/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PartManagerBase } from "./PartManagerBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var ActiveXBinaryPartManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ActiveXBinaryPartManager, _super);
    function ActiveXBinaryPartManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ActiveXBinaryPartManager.prototype.get_m = function () {
        return "application/vnd.ms-office.activeX";
    };
    Object.defineProperty(ActiveXBinaryPartManager.prototype, "m", {
        get: function () {
            return this.get_m();
        },
        enumerable: false,
        configurable: true
    });
    ActiveXBinaryPartManager.prototype.n = function (a) {
        switch (a) {
            case 0: return "/xl/activeX.bin";
            default: return null;
        }
    };
    ActiveXBinaryPartManager.prototype.o = function (a) {
        switch (a) {
            case 0: return ActiveXBinaryPartManager.u;
            case 1: return ActiveXBinaryPartManager.t;
            default: return ActiveXBinaryPartManager.u;
        }
    };
    ActiveXBinaryPartManager.prototype.get_g = function () {
        return true;
    };
    Object.defineProperty(ActiveXBinaryPartManager.prototype, "g", {
        get: function () {
            return this.get_g();
        },
        enumerable: false,
        configurable: true
    });
    ActiveXBinaryPartManager.$t = markType(ActiveXBinaryPartManager, 'ActiveXBinaryPartManager', PartManagerBase.$);
    ActiveXBinaryPartManager.u = "http://schemas.microsoft.com/office/2006/relationships/activeXControlBinary";
    ActiveXBinaryPartManager.t = "http://schemas.microsoft.com/office/2006/relationships/activeXControlBinary";
    return ActiveXBinaryPartManager;
}(PartManagerBase));
export { ActiveXBinaryPartManager };
