/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { PartManagerBase } from "./PartManagerBase";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var ActiveXPartManager = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ActiveXPartManager, _super);
    function ActiveXPartManager() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    ActiveXPartManager.prototype.get_m = function () {
        return "application/vnd.ms-office.activeX+xml";
    };
    Object.defineProperty(ActiveXPartManager.prototype, "m", {
        get: function () {
            return this.get_m();
        },
        enumerable: false,
        configurable: true
    });
    ActiveXPartManager.prototype.n = function (a) {
        switch (a) {
            case 0: return "/xl/activeX.xml";
            default: return null;
        }
    };
    ActiveXPartManager.prototype.o = function (a) {
        switch (a) {
            case 0: return ActiveXPartManager.u;
            case 1: return ActiveXPartManager.t;
            default: return ActiveXPartManager.u;
        }
    };
    ActiveXPartManager.prototype.get_g = function () {
        return true;
    };
    Object.defineProperty(ActiveXPartManager.prototype, "g", {
        get: function () {
            return this.get_g();
        },
        enumerable: false,
        configurable: true
    });
    ActiveXPartManager.$t = markType(ActiveXPartManager, 'ActiveXPartManager', PartManagerBase.$);
    ActiveXPartManager.u = "http://schemas.openxmlformats.org/officeDocument/2006/relationships/control";
    ActiveXPartManager.t = "http://purl.oclc.org/ooxml/officeDocument/relationships/control";
    return ActiveXPartManager;
}(PartManagerBase));
export { ActiveXPartManager };
