/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, typeCast, markType, getInstanceType } from "igniteui-angular-core";
import { ISupportSetProperty_$type } from "./ISupportSetProperty";
import { CT_ShapeProperties_DML } from "./CT_ShapeProperties_DML";
import { CT_TextBodyProperties_DML } from "./CT_TextBodyProperties_DML";
import { CT_TextListStyle_DML } from "./CT_TextListStyle_DML";
import { CT_ShapeStyle } from "./CT_ShapeStyle";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
/**
 * @hidden
 */
var CT_DefaultShapeDefinition = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_DefaultShapeDefinition, _super);
    function CT_DefaultShapeDefinition() {
        var _this = _super.call(this) || this;
        _this.d = null;
        _this.f = null;
        _this.h = null;
        _this.j = null;
        _this.b = null;
        return _this;
    }
    Object.defineProperty(CT_DefaultShapeDefinition.prototype, "c", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_DefaultShapeDefinition.prototype, "e", {
        get: function () {
            return this.f;
        },
        set: function (a) {
            this.f = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_DefaultShapeDefinition.prototype, "g", {
        get: function () {
            return this.h;
        },
        set: function (a) {
            this.h = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_DefaultShapeDefinition.prototype, "i", {
        get: function () {
            return this.j;
        },
        set: function (a) {
            this.j = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_DefaultShapeDefinition.prototype, "a", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: false,
        configurable: true
    });
    CT_DefaultShapeDefinition.prototype.setProperty = function (a, b) {
        switch (a) {
            case 1570:
                this.c = typeCast(CT_ShapeProperties_DML.$, b);
                break;
            case 136:
                this.e = typeCast(CT_TextBodyProperties_DML.$, b);
                break;
            case 938:
                this.g = typeCast(CT_TextListStyle_DML.$, b);
                break;
            case 1618:
                this.i = typeCast(CT_ShapeStyle.$, b);
                break;
            case 601:
                this.a = typeCast(CT_OfficeArtExtensionList.$, b);
                break;
            default: break;
        }
    };
    CT_DefaultShapeDefinition.prototype.toString = function () {
        var a = getInstanceType(this);
        return a != null ? a.typeName : _super.prototype.toString.call(this);
    };
    CT_DefaultShapeDefinition.$t = markType(CT_DefaultShapeDefinition, 'CT_DefaultShapeDefinition', Base.$, [ISupportSetProperty_$type]);
    return CT_DefaultShapeDefinition;
}(Base));
export { CT_DefaultShapeDefinition };
