/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, fromEnum, markType, getInstanceType } from "igniteui-angular-core";
import { ST_EntityType_$type } from "./ST_EntityType";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
/**
 * @hidden
 */
var CT_GeoHierarchyEntity = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_GeoHierarchyEntity, _super);
    function CT_GeoHierarchyEntity() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.g = null;
        _this.e = null;
        _this.c = 0;
        return _this;
    }
    Object.defineProperty(CT_GeoHierarchyEntity.prototype, "f", {
        get: function () {
            return this.g;
        },
        set: function (a) {
            this.g = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_GeoHierarchyEntity.prototype, "d", {
        get: function () {
            return this.e;
        },
        set: function (a) {
            this.e = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_GeoHierarchyEntity.prototype, "b", {
        get: function () {
            return this.c;
        },
        set: function (a) {
            this.c = a;
        },
        enumerable: false,
        configurable: true
    });
    CT_GeoHierarchyEntity.a = function (a) {
        var b = null;
        var c = null;
        var d = 11;
        var e = CT_GeoHierarchyEntity.i(a, b, c, d);
        b = e.p1;
        c = e.p2;
        d = e.p3;
        return ((function () {
            var $ret = new CT_GeoHierarchyEntity();
            $ret.d = c;
            $ret.b = d;
            $ret.f = b;
            return $ret;
        })());
    };
    CT_GeoHierarchyEntity.i = function (a, b, c, d) {
        var e_1, _a;
        b = null;
        c = null;
        d = 0;
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var e = _c.value;
                switch (e.a.e(a.d)) {
                    case "entityName":
                        b = e.d;
                        break;
                    case "entityId":
                        c = e.d;
                        break;
                    case "entityType":
                        d = XmlNamespaceDefinitionBase.b(ST_EntityType_$type, e.d);
                        break;
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        ;
        return {
            p1: b,
            p2: c,
            p3: d
        };
    };
    CT_GeoHierarchyEntity.j = function (a, b, c, d, e) {
        a.ad.p(b, "cx");
        var f = null;
        var g = null;
        if (c != null) {
            g = "entityId";
            f = c;
            a.ad.h(g, f);
        }
        if (d != null) {
            g = "entityName";
            f = d;
            a.ad.h(g, f);
        }
        g = "entityType";
        f = XmlNamespaceDefinitionBase.p(ST_EntityType_$type, e);
        a.ad.h(g, f);
        ;
    };
    CT_GeoHierarchyEntity.prototype.toString = function () {
        var a = getInstanceType(this);
        return a != null ? a.typeName : _super.prototype.toString.call(this);
    };
    CT_GeoHierarchyEntity.$t = markType(CT_GeoHierarchyEntity, 'CT_GeoHierarchyEntity');
    return CT_GeoHierarchyEntity;
}(Base));
export { CT_GeoHierarchyEntity };
