/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends, __values } from "tslib";
import { Base, toNullable, Number_$type, fromEnum, markType } from "igniteui-angular-core";
import { ST_SlicerStyleType_$type } from "./ST_SlicerStyleType";
import { XmlNamespaceDefinitionBase } from "./XmlNamespaceDefinitionBase";
import { CultureInfo } from "igniteui-angular-core";
import { parseUInt32_1 } from "igniteui-angular-core";
/**
 * @hidden
 */
var CT_SlicerStyleElement = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(CT_SlicerStyleElement, _super);
    function CT_SlicerStyleElement() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b = 0;
        _this.d = toNullable(Number_$type, null);
        return _this;
    }
    Object.defineProperty(CT_SlicerStyleElement.prototype, "a", {
        get: function () {
            return this.b;
        },
        set: function (a) {
            this.b = a;
        },
        enumerable: false,
        configurable: true
    });
    Object.defineProperty(CT_SlicerStyleElement.prototype, "c", {
        get: function () {
            return this.d;
        },
        set: function (a) {
            this.d = a;
        },
        enumerable: false,
        configurable: true
    });
    CT_SlicerStyleElement.e = function (a, b, c) {
        var e_1, _a;
        b = 0;
        c = toNullable(Number_$type, null);
        try {
            for (var _b = __values(fromEnum(a.ab.u)), _c = _b.next(); !_c.done; _c = _b.next()) {
                var d = _c.value;
                switch (d.a.e(a.d)) {
                    case "type":
                        b = XmlNamespaceDefinitionBase.b(ST_SlicerStyleType_$type, d.d);
                        break;
                    case "dxfId":
                        c = toNullable(Number_$type, parseUInt32_1(d.d, CultureInfo.invariantCulture));
                        break;
                    default: break;
                }
            }
        }
        catch (e_1_1) {
            e_1 = { error: e_1_1 };
        }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return))
                    _a.call(_b);
            }
            finally {
                if (e_1)
                    throw e_1.error;
            }
        }
        ;
        return {
            p1: b,
            p2: c
        };
    };
    CT_SlicerStyleElement.f = function (a, b, c, d) {
        a.ad.p(b, null);
        var e = null;
        var f = null;
        if (c.hasValue) {
            f = "dxfId";
            e = c.value.toString();
            a.ad.h(f, e);
        }
        f = "type";
        e = XmlNamespaceDefinitionBase.p(ST_SlicerStyleType_$type, d);
        a.ad.h(f, e);
        ;
    };
    CT_SlicerStyleElement.$t = markType(CT_SlicerStyleElement, 'CT_SlicerStyleElement');
    return CT_SlicerStyleElement;
}(Base));
export { CT_SlicerStyleElement };
