/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the various logical operators used to combine the conditions of the [[CustomFilter]].
 * @see [[CustomFilter.conditionalOperator]]
 */
export var ConditionalOperator = /*@__PURE__*/ (function (ConditionalOperator) {
    /**
     * Filter in values where only [[CustomFilter.condition1]] and [[CustomFilter.condition2]] pass.
     */
    ConditionalOperator[ConditionalOperator["And"] = 0] = "And";
    /**
     * Filter in values where either [[CustomFilter.condition1]] or [[CustomFilter.condition2]] (or both) pass.
     */
    ConditionalOperator[ConditionalOperator["Or"] = 1] = "Or";
    return ConditionalOperator;
})({});
/**
 * @hidden
 */
export var ConditionalOperator_$type = markEnum('ConditionalOperator', 'And,0|Or,1');
