/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine whether <see cref="DataBarConditionalFormat">data bars</see> are filled with a solid color or
 * with a gradient.
 */
export var DataBarDirection = /*@__PURE__*/ (function (DataBarDirection) {
    /**
     * The direction the data bar is displayed is based on context.
     */
    DataBarDirection[DataBarDirection["Context"] = -5002] = "Context";
    /**
     * The data bar is displayed from left-to-right.
     */
    DataBarDirection[DataBarDirection["LeftToRight"] = -5003] = "LeftToRight";
    /**
     * The data bar is displayed from right-to-left.
     */
    DataBarDirection[DataBarDirection["RightToLeft"] = -5004] = "RightToLeft";
    return DataBarDirection;
})({});
/**
 * @hidden
 */
export var DataBarDirection_$type = markEnum('DataBarDirection', 'Context,-5002|LeftToRight,-5003|RightToLeft,-5004');
