/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { Base, markType } from "igniteui-angular-core";
import { AlignmentInfo } from "./AlignmentInfo";
import { BorderInfo } from "./BorderInfo";
import { FillInfo } from "./FillInfo";
import { SerializationNumberFormatInfo } from "./SerializationNumberFormatInfo";
import { ProtectionInfo } from "./ProtectionInfo";
import { ExcelUtils } from "./ExcelUtils";
import { NoOpFontDefaultsResolver } from "./NoOpFontDefaultsResolver";
/**
 * @hidden
 */
var DxfInfo = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DxfInfo, _super);
    function DxfInfo(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.b = null;
        _this.c = null;
        _this.e = null;
        _this.a = null;
        _this.d = null;
        _this.g = null;
        _this.f = null;
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    var c = _rest[0];
                    var d = _rest[1];
                    if (ExcelUtils.bw(d.formatOptions, 2)) {
                        _this.b = AlignmentInfo.e(d, true);
                    }
                    if (ExcelUtils.bw(d.formatOptions, 8)) {
                        _this.c = BorderInfo.a(c, d);
                    }
                    if (ExcelUtils.bw(d.formatOptions, 16)) {
                        _this.e = FillInfo.a(c, d);
                    }
                    if (ExcelUtils.bw(d.formatOptions, 1)) {
                        _this.g = SerializationNumberFormatInfo.a(d);
                    }
                    if (ExcelUtils.bw(d.formatOptions, 32)) {
                        _this.f = ProtectionInfo.b(d, true);
                    }
                    if (ExcelUtils.bw(d.formatOptions, 4)) {
                        _this.a = d._bp.d._ak(NoOpFontDefaultsResolver.a);
                    }
                }
                break;
        }
        return _this;
    }
    DxfInfo.prototype.h = function (a) {
        var b = a._b._cd(2);
        if (this.b != null) {
            this.b.ai(b);
        }
        if (this.c != null) {
            this.c.x(b, a);
        }
        if (this.e != null) {
            this.e.h(b, a);
        }
        if (this.a != null) {
            b.font.setFontFormatting(this.a);
        }
        if (this.d != null) {
            b.font.colorInfo = this.d.c(a);
        }
        if (this.g != null) {
            this.g.d(b);
        }
        if (this.f != null) {
            this.f.k(b);
        }
        return b;
    };
    DxfInfo.$t = markType(DxfInfo, 'DxfInfo');
    return DxfInfo;
}(Base));
export { DxfInfo };
