/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Constants which determine the style of the endpoint
 * of a line on a line chart.
 */
export var EndStyleCap = /*@__PURE__*/ (function (EndStyleCap) {
    /**
     * The line terminates with a cap.
     */
    EndStyleCap[EndStyleCap["Cap"] = 1] = "Cap";
    /**
     * No cap is displayed at the end of the line.
     */
    EndStyleCap[EndStyleCap["NoCap"] = 2] = "NoCap";
    return EndStyleCap;
})({});
/**
 * @hidden
 */
export var EndStyleCap_$type = markEnum('EndStyleCap', 'Cap,1|NoCap,2');
