/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { ValueType, toNullable, typeCast, markStruct } from "igniteui-angular-core";
import { ST_Angle } from "./ST_Angle";
import { DocCoreUtils } from "./DocCoreUtils";
/**
 * @hidden
 */
var ST_FixedAngle = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(ST_FixedAngle, _super);
    function ST_FixedAngle(a) {
        var _rest = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            _rest[_i - 1] = arguments[_i];
        }
        var _this = _super.call(this) || this;
        _this.a = new ST_Angle();
        a = (a == void 0) ? 0 : a;
        switch (a) {
            case 0: break;
            case 1:
                {
                    var c = _rest[0];
                    DocCoreUtils.aw(ST_FixedAngle.$, c.n(), "value", -5400000, 5400000);
                    _this.a = c;
                }
                break;
        }
        return _this;
    }
    ST_FixedAngle.prototype.equals = function (a) {
        var b = toNullable(ST_FixedAngle.$, typeCast(ST_FixedAngle.$, a));
        if (ST_FixedAngle.k(b, toNullable(ST_FixedAngle.$, null))) {
            return false;
        }
        return ST_FixedAngle.h(this, b.getValueOrDefault());
    };
    ST_FixedAngle.prototype.getHashCode = function () {
        return this.a.getHashCode();
    };
    ST_FixedAngle.prototype.toString = function () {
        return this.a.toString();
    };
    ST_FixedAngle.d = function (a) {
        return ST_FixedAngle.e(ST_Angle.a(a));
    };
    ST_FixedAngle.g = function (a) {
        var b = ST_FixedAngle.r(a);
        if (ST_FixedAngle.k(b, toNullable(ST_FixedAngle.$, null))) {
            return b.getValueOrDefault();
        }
        throw DocCoreUtils.n(ST_FixedAngle.$, a);
    };
    ST_FixedAngle.prototype.s = function () {
        return this.a.n();
    };
    ST_FixedAngle.r = function (a) {
        return ST_FixedAngle.q(ST_Angle.m(a));
    };
    ST_FixedAngle.h = function (a, b) {
        return ST_Angle.c(a.a, b.a);
    };
    ST_FixedAngle.i = function (a, b) {
        if (!a.hasValue) {
            return !b.hasValue;
        }
        else if (!b.hasValue) {
            return false;
        }
        return ST_FixedAngle.h(a.value, b.value);
    };
    ST_FixedAngle.j = function (a, b) {
        return !(ST_FixedAngle.h(a, b));
    };
    ST_FixedAngle.k = function (a, b) {
        if (!a.hasValue) {
            return b.hasValue;
        }
        else if (!b.hasValue) {
            return true;
        }
        return ST_FixedAngle.j(a.value, b.value);
    };
    ST_FixedAngle.e = function (a) {
        return new ST_FixedAngle(1, a);
    };
    ST_FixedAngle.q = function (a) {
        if (!a.hasValue) {
            return toNullable(ST_FixedAngle.$, null);
        }
        return toNullable(ST_FixedAngle.$, ST_FixedAngle.e(a.value));
    };
    ST_FixedAngle.b = function (a) {
        return a.a;
    };
    ST_FixedAngle.p = function (a) {
        if (!a.hasValue) {
            return toNullable(ST_Angle.$, null);
        }
        return toNullable(ST_Angle.$, ST_FixedAngle.b(a.value));
    };
    ST_FixedAngle.$t = markStruct(ST_FixedAngle, 'ST_FixedAngle');
    return ST_FixedAngle;
}(ValueType));
export { ST_FixedAngle };
