/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { markEnum } from "igniteui-angular-core";
/**
 * Represents the ways to scale a worksheet when it is printed.
 */
export var ScalingType = /*@__PURE__*/ (function (ScalingType) {
    /**
     * The scaling factor is used to scale the worksheet when printing.
     */
    ScalingType[ScalingType["UseScalingFactor"] = 0] = "UseScalingFactor";
    /**
     * The page maximums are used to determine how many pages the worksheet can be printed on.
     * Less pages can be used if there is not enough printable content in the worksheet.
     */
    ScalingType[ScalingType["FitToPages"] = 1] = "FitToPages";
    return ScalingType;
})({});
/**
 * @hidden
 */
export var ScalingType_$type = markEnum('ScalingType', 'UseScalingFactor,0|FitToPages,1');
