/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionAreas = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionAreas, _super);
    function UltraCalcFunctionAreas() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionAreas.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isReference == false) {
            if (c.isError) {
                return c;
            }
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        return new ExcelCalcValue(c._b(false).length);
    };
    UltraCalcFunctionAreas.prototype.get_name = function () {
        return "areas";
    };
    Object.defineProperty(UltraCalcFunctionAreas.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAreas.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionAreas.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAreas.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionAreas.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAreas.prototype._v = function (a) {
        return false;
    };
    UltraCalcFunctionAreas.$t = markType(UltraCalcFunctionAreas, 'UltraCalcFunctionAreas', BuiltInFunctionBase.$);
    return UltraCalcFunctionAreas;
}(BuiltInFunctionBase));
export { UltraCalcFunctionAreas };
