/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
import { UltraCalcConditionalFunctionBase } from "./UltraCalcConditionalFunctionBase";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
/**
 * @hidden
 */
var UltraCalcFunctionAverageIfs = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionAverageIfs, _super);
    function UltraCalcFunctionAverageIfs() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionAverageIfs.prototype.evaluate = function (a, b) {
        return UltraCalcConditionalFunctionBase._ak(a, b, 0, function (c, d) { return new ExcelCalcValue(d == 0 ? new ExcelCalcErrorValue(2) : (c / d)); }, function (c, d) { return c + d; });
    };
    UltraCalcFunctionAverageIfs.prototype.get_name = function () {
        return "averageifs";
    };
    Object.defineProperty(UltraCalcFunctionAverageIfs.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAverageIfs.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionAverageIfs.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAverageIfs.prototype.get_maxArgs = function () {
        return 0x7FFFFFFF;
    };
    Object.defineProperty(UltraCalcFunctionAverageIfs.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionAverageIfs.$t = markType(UltraCalcFunctionAverageIfs, 'UltraCalcFunctionAverageIfs', BuiltInFunctionBase.$);
    return UltraCalcFunctionAverageIfs;
}(BuiltInFunctionBase));
export { UltraCalcFunctionAverageIfs };
