/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { UltraCalcFunctionBitOperation } from "./UltraCalcFunctionBitOperation";
/**
 * @hidden
 */
var UltraCalcFunctionBitLShift = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionBitLShift, _super);
    function UltraCalcFunctionBitLShift() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionBitLShift.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.j(a, true, function (c, d) { return UltraCalcFunctionBitOperation._ak(c, d); });
    };
    UltraCalcFunctionBitLShift.prototype.get_name = function () {
        return "bitlshift";
    };
    Object.defineProperty(UltraCalcFunctionBitLShift.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitLShift.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionBitLShift.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitLShift.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionBitLShift.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitLShift.$t = markType(UltraCalcFunctionBitLShift, 'UltraCalcFunctionBitLShift', BuiltInFunctionBase.$);
    return UltraCalcFunctionBitLShift;
}(BuiltInFunctionBase));
export { UltraCalcFunctionBitLShift };
