/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { markType } from "igniteui-angular-core";
import { CalcFunctionUtilities } from "./CalcFunctionUtilities";
import { UltraCalcFunctionBitOperation } from "./UltraCalcFunctionBitOperation";
/**
 * @hidden
 */
var UltraCalcFunctionBitRShift = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionBitRShift, _super);
    function UltraCalcFunctionBitRShift() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionBitRShift.prototype.evaluate = function (a, b) {
        return CalcFunctionUtilities.j(a, true, function (c, d) { return UltraCalcFunctionBitOperation._ak(c, -d); });
    };
    UltraCalcFunctionBitRShift.prototype.get_name = function () {
        return "bitrshift";
    };
    Object.defineProperty(UltraCalcFunctionBitRShift.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitRShift.prototype.get_minArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionBitRShift.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitRShift.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionBitRShift.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionBitRShift.$t = markType(UltraCalcFunctionBitRShift, 'UltraCalcFunctionBitRShift', BuiltInFunctionBase.$);
    return UltraCalcFunctionBitRShift;
}(BuiltInFunctionBase));
export { UltraCalcFunctionBitRShift };
