/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
import { round10N } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionDB = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionDB, _super);
    function UltraCalcFunctionDB() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionDB.prototype.evaluate = function (a, b) {
        var c = 12;
        if (b > 4) {
            c = a.pop()._toInt321();
        }
        var d = a.pop()._toInt321();
        if (d <= 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var e;
        if (!((function () { var f = a.pop()._toDouble1(e); e = f.p0; return f.ret; })()) || e <= 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var f, g;
        if (!((function () { var h = a.pop()._toDouble1(f); f = h.p0; return h.ret; })()) || !((function () { var h = a.pop()._toDouble1(g); g = h.p0; return h.ret; })())) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var h = round10N(1 - Math.pow(f / g, 1 / e), 3);
        if (d > e + 1) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        if ((d == e + 1) && c == 12) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var i = 0;
        var j = 0;
        var k = g;
        for (var l = 1; l <= d; l++) {
            if (l == 1) {
                i = k * h * (c / 12);
            }
            else if ((l == (e + 1)) && c < 12) {
                i = (k * h * (12 - c)) / 12;
            }
            else {
                i = k * h;
            }
            j += i;
            k -= i;
        }
        return new ExcelCalcValue(i);
    };
    UltraCalcFunctionDB.prototype.get_name = function () {
        return "db";
    };
    Object.defineProperty(UltraCalcFunctionDB.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDB.prototype.get_minArgs = function () {
        return 4;
    };
    Object.defineProperty(UltraCalcFunctionDB.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDB.prototype.get_maxArgs = function () {
        return 5;
    };
    Object.defineProperty(UltraCalcFunctionDB.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDB.$t = markType(UltraCalcFunctionDB, 'UltraCalcFunctionDB', BuiltInFunctionBase.$);
    return UltraCalcFunctionDB;
}(BuiltInFunctionBase));
export { UltraCalcFunctionDB };
