/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { markType } from "igniteui-angular-core";
import { CalcManagerUtilities } from "./CalcManagerUtilities";
/**
 * @hidden
 */
var UltraCalcFunctionDateAdd = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionDateAdd, _super);
    function UltraCalcFunctionDateAdd() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionDateAdd.prototype.evaluate = function (a, b) {
        var c = a.pop()._toDateTime1();
        var d;
        if (!((function () { var e = a.pop()._toDouble1(d); d = e.p0; return e.ret; })())) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var e = a.pop().toString().toLowerCase().trim();
        var f = CalcManagerUtilities.c(e, d, c);
        return new ExcelCalcValue(f);
    };
    UltraCalcFunctionDateAdd.prototype.get_name = function () {
        return "dateadd";
    };
    Object.defineProperty(UltraCalcFunctionDateAdd.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDateAdd.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionDateAdd.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDateAdd.prototype.get_maxArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionDateAdd.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionDateAdd.$t = markType(UltraCalcFunctionDateAdd, 'UltraCalcFunctionDateAdd', BuiltInFunctionBase.$);
    return UltraCalcFunctionDateAdd;
}(BuiltInFunctionBase));
export { UltraCalcFunctionDateAdd };
