/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { ErfUtils } from "./ErfUtils";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionErf = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionErf, _super);
    function UltraCalcFunctionErf() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionErf.prototype.evaluate = function (a, b) {
        var c = 0;
        var d = null;
        if (b == 2) {
            d = a.pop();
        }
        var e = a.pop();
        if (e.isError) {
            return new ExcelCalcValue(e.toErrorValue());
        }
        else if (e.isBoolean) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(1));
        }
        if (b == 2) {
            if (d.isError) {
                return new ExcelCalcValue(d.toErrorValue());
            }
            else if (d.isBoolean) {
                return new ExcelCalcValue(new ExcelCalcErrorValue(1));
            }
            c = d._toDouble3();
        }
        var f = e._toDouble3();
        var g = ErfUtils.c(f);
        if (b == 2) {
            g = ErfUtils.c(c) - g;
        }
        return new ExcelCalcValue(g);
    };
    UltraCalcFunctionErf.prototype.get_name = function () {
        return "erf";
    };
    Object.defineProperty(UltraCalcFunctionErf.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErf.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionErf.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErf.prototype.get_maxArgs = function () {
        return 2;
    };
    Object.defineProperty(UltraCalcFunctionErf.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionErf.$t = markType(UltraCalcFunctionErf, 'UltraCalcFunctionErf', BuiltInFunctionBase.$);
    return UltraCalcFunctionErf;
}(BuiltInFunctionBase));
export { UltraCalcFunctionErf };
