/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { ExcelCalcErrorValue } from "./ExcelCalcErrorValue";
import { FinancialUtils } from "./FinancialUtils";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionNPer = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionNPer, _super);
    function UltraCalcFunctionNPer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionNPer.prototype.evaluate = function (a, b) {
        var c = 0;
        if (b == 5) {
            c = a.pop()._toInt321();
        }
        var d = 0;
        if (b >= 4 && !((function () { var e = a.pop()._toDouble1(d); d = e.p0; return e.ret; })())) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var e, f, g;
        if (!((function () { var h = a.pop()._toDouble1(e); e = h.p0; return h.ret; })()) || !((function () { var h = a.pop()._toDouble1(f); f = h.p0; return h.ret; })()) || f == 0 || !((function () { var h = a.pop()._toDouble1(g); g = h.p0; return h.ret; })())) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        if (g <= -1) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        if (g == 0 && f == 0) {
            return new ExcelCalcValue(new ExcelCalcErrorValue(4));
        }
        var h = c;
        var i = FinancialUtils.nPer(g, f, e, d, h);
        return new ExcelCalcValue(i);
    };
    UltraCalcFunctionNPer.prototype.get_name = function () {
        return "nper";
    };
    Object.defineProperty(UltraCalcFunctionNPer.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionNPer.prototype.get_minArgs = function () {
        return 3;
    };
    Object.defineProperty(UltraCalcFunctionNPer.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionNPer.prototype.get_maxArgs = function () {
        return 5;
    };
    Object.defineProperty(UltraCalcFunctionNPer.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionNPer.$t = markType(UltraCalcFunctionNPer, 'UltraCalcFunctionNPer', BuiltInFunctionBase.$);
    return UltraCalcFunctionNPer;
}(BuiltInFunctionBase));
export { UltraCalcFunctionNPer };
