/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionRadians = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRadians, _super);
    function UltraCalcFunctionRadians() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    UltraCalcFunctionRadians.prototype.evaluate = function (a, b) {
        var c = a.pop();
        if (c.isError) {
            return new ExcelCalcValue(c.toErrorValue());
        }
        var d = c._toDouble3();
        var e = UltraCalcFunctionRadians._ak(d);
        return new ExcelCalcValue(e);
    };
    UltraCalcFunctionRadians.prototype.get_name = function () {
        return "radians";
    };
    Object.defineProperty(UltraCalcFunctionRadians.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRadians.prototype.get_minArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionRadians.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRadians.prototype.get_maxArgs = function () {
        return 1;
    };
    Object.defineProperty(UltraCalcFunctionRadians.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRadians._ak = function (a) {
        var b = Math.PI / 180;
        return a * b;
    };
    UltraCalcFunctionRadians.prototype.doesParameterAllowIntermediateResultArray = function (a, b) {
        return true;
    };
    UltraCalcFunctionRadians.$t = markType(UltraCalcFunctionRadians, 'UltraCalcFunctionRadians', BuiltInFunctionBase.$);
    return UltraCalcFunctionRadians;
}(BuiltInFunctionBase));
export { UltraCalcFunctionRadians };
