/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { BuiltInFunctionBase } from "./BuiltInFunctionBase";
import { ExcelCalcValue } from "./ExcelCalcValue";
import { Random } from "igniteui-angular-core";
import { markType } from "igniteui-angular-core";
/**
 * @hidden
 */
var UltraCalcFunctionRand = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(UltraCalcFunctionRand, _super);
    function UltraCalcFunctionRand() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this._ak = new Random(0);
        return _this;
    }
    UltraCalcFunctionRand.prototype.evaluate = function (a, b) {
        return new ExcelCalcValue(this._ak.nextDouble());
    };
    UltraCalcFunctionRand.prototype.get_name = function () {
        return "rand";
    };
    Object.defineProperty(UltraCalcFunctionRand.prototype, "name", {
        get: function () {
            return this.get_name();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRand.prototype.get_minArgs = function () {
        return 0;
    };
    Object.defineProperty(UltraCalcFunctionRand.prototype, "minArgs", {
        get: function () {
            return this.get_minArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRand.prototype.get_maxArgs = function () {
        return 0;
    };
    Object.defineProperty(UltraCalcFunctionRand.prototype, "maxArgs", {
        get: function () {
            return this.get_maxArgs();
        },
        enumerable: false,
        configurable: true
    });
    UltraCalcFunctionRand.$t = markType(UltraCalcFunctionRand, 'UltraCalcFunctionRand', BuiltInFunctionBase.$);
    return UltraCalcFunctionRand;
}(BuiltInFunctionBase));
export { UltraCalcFunctionRand };
