import { Base, Type } from "igniteui-angular-core";
import { WorkbookLoadManager } from "./WorkbookLoadManager";
import { WorkbookSaveManager } from "./WorkbookSaveManager";
import { WorkItem } from "./WorkItem";
/**
 * @hidden
 */
export declare abstract class BiffRecordBase$3<RecordTypeEnum, LoadContextType extends WorkbookLoadManager, SaveContextType extends WorkbookSaveManager> extends Base {
    static $t: Type;
    protected $recordTypeEnum: Type;
    protected $loadContextType: Type;
    protected $saveContextType: Type;
    constructor($recordTypeEnum: Type, $loadContextType: Type, $saveContextType: Type);
    protected get_e(): boolean;
    get e(): boolean;
    abstract h(a: LoadContextType): void;
    a(a: LoadContextType): WorkItem;
    abstract i(a: SaveContextType): void;
    b(a: SaveContextType): WorkItem;
    abstract get d(): RecordTypeEnum;
    private static g;
    static c<RecordTypeEnum, LoadContextType extends WorkbookLoadManager, SaveContextType extends WorkbookSaveManager>($recordTypeEnum: Type, $loadContextType: Type, $saveContextType: Type, a: RecordTypeEnum, b: (type: RecordTypeEnum) => BiffRecordBase$3<RecordTypeEnum, LoadContextType, SaveContextType>): BiffRecordBase$3<RecordTypeEnum, LoadContextType, SaveContextType>;
}
