import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_ColorScheme } from "./CT_ColorScheme";
import { CT_FontScheme } from "./CT_FontScheme";
import { CT_StyleMatrix } from "./CT_StyleMatrix";
import { CT_OfficeArtExtensionList } from "./CT_OfficeArtExtensionList";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_BaseStyles extends Base implements ISupportSetProperty {
    static $t: Type;
    private b;
    private d;
    private h;
    private f;
    constructor();
    get a(): CT_ColorScheme;
    set a(a: CT_ColorScheme);
    get c(): CT_FontScheme;
    set c(a: CT_FontScheme);
    get g(): CT_StyleMatrix;
    set g(a: CT_StyleMatrix);
    get e(): CT_OfficeArtExtensionList;
    set e(a: CT_OfficeArtExtensionList);
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
