import { Base, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_Font } from "./CT_Font";
import { CT_NumFmt } from "./CT_NumFmt";
import { CT_Fill } from "./CT_Fill";
import { CT_CellAlignment } from "./CT_CellAlignment";
import { CT_Border } from "./CT_Border";
import { CT_CellProtection } from "./CT_CellProtection";
import { CT_ExtensionList } from "./CT_ExtensionList";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_Dxf extends Base implements ISupportSetProperty {
    static $t: Type;
    private l;
    private n;
    private j;
    private f;
    private d;
    private h;
    private b;
    constructor();
    get k(): CT_Font;
    set k(a: CT_Font);
    get m(): CT_NumFmt;
    set m(a: CT_NumFmt);
    get i(): CT_Fill;
    set i(a: CT_Fill);
    get e(): CT_CellAlignment;
    set e(a: CT_CellAlignment);
    get c(): CT_Border;
    set c(a: CT_Border);
    get g(): CT_CellProtection;
    set g(a: CT_CellProtection);
    get a(): CT_ExtensionList;
    set a(a: CT_ExtensionList);
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
