import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { ISupportSetProperty } from "./ISupportSetProperty";
import { CT_PivotAreaReferences } from "./CT_PivotAreaReferences";
import { CT_ExtensionList } from "./CT_ExtensionList";
import { ST_PivotAreaType } from "./ST_PivotAreaType";
import { ST_Axis } from "./ST_Axis";
import { XmlPartManagerBase } from "./XmlPartManagerBase";
import { ElementPropertyIds } from "./ElementPropertyIds";
/**
 * @hidden
 */
export declare class CT_PivotArea extends Base implements ISupportSetProperty {
    static $t: Type;
    private d;
    private b;
    private af;
    private g;
    private m;
    private z;
    private x;
    private v;
    private i;
    private ab;
    private aj;
    private k;
    private ad;
    private ah;
    constructor();
    get c(): CT_PivotAreaReferences;
    set c(a: CT_PivotAreaReferences);
    get a(): CT_ExtensionList;
    set a(a: CT_ExtensionList);
    get ae(): Nullable$1<number>;
    set ae(a: Nullable$1<number>);
    get f(): ST_PivotAreaType;
    set f(a: ST_PivotAreaType);
    get l(): boolean;
    set l(a: boolean);
    get y(): boolean;
    set y(a: boolean);
    get w(): boolean;
    set w(a: boolean);
    get u(): boolean;
    set u(a: boolean);
    get h(): boolean;
    set h(a: boolean);
    get aa(): boolean;
    set aa(a: boolean);
    get ai(): string;
    set ai(a: string);
    get j(): boolean;
    set j(a: boolean);
    get ac(): Nullable$1<ST_Axis>;
    set ac(a: Nullable$1<ST_Axis>);
    get ag(): Nullable$1<number>;
    set ag(a: Nullable$1<number>);
    static al(a: XmlPartManagerBase, b: Nullable$1<number>, c: ST_PivotAreaType, d: boolean, e: boolean, f: boolean, g: boolean, h: boolean, i: boolean, j: string, k: boolean, l: Nullable$1<ST_Axis>, m: Nullable$1<number>): {
        p1: Nullable$1<number>;
        p2: ST_PivotAreaType;
        p3: boolean;
        p4: boolean;
        p5: boolean;
        p6: boolean;
        p7: boolean;
        p8: boolean;
        p9: string;
        p10: boolean;
        p11: Nullable$1<ST_Axis>;
        p12: Nullable$1<number>;
    };
    static am(a: XmlPartManagerBase, b: string, c: Nullable$1<ST_Axis>, d: Nullable$1<number>, e: Nullable$1<number>, f: boolean, g: boolean, h: boolean, i: boolean, j: boolean, k: boolean, l: string, m: boolean, n: ST_PivotAreaType): void;
    setProperty(a: ElementPropertyIds, b: any): void;
    toString(): string;
}
