import { Base, Nullable$1, Type } from "igniteui-angular-core";
import { CT_TextFont } from "./CT_TextFont";
import { ST_TextUnderlineType } from "./ST_TextUnderlineType";
import { ST_TextStrikeType } from "./ST_TextStrikeType";
import { ST_TextCapsType } from "./ST_TextCapsType";
import { ST_TextPoint } from "./ST_TextPoint";
import { ST_Percentage } from "./ST_Percentage";
/**
 * @hidden
 */
export declare class CT_TextCharacterPropertiesBase extends Base {
    static $t: Type;
    c: CT_TextFont;
    b: CT_TextFont;
    a: CT_TextFont;
    k: Nullable$1<boolean>;
    v: string;
    t: string;
    r: Nullable$1<number>;
    d: Nullable$1<boolean>;
    i: Nullable$1<boolean>;
    s: Nullable$1<ST_TextUnderlineType>;
    q: Nullable$1<ST_TextStrikeType>;
    j: Nullable$1<number>;
    f: Nullable$1<ST_TextCapsType>;
    p: Nullable$1<ST_TextPoint>;
    m: Nullable$1<boolean>;
    e: Nullable$1<ST_Percentage>;
    l: Nullable$1<boolean>;
    g: Nullable$1<boolean>;
    h: Nullable$1<boolean>;
    n: Nullable$1<boolean>;
    o: Nullable$1<number>;
    u: string;
}
