import { Base, IEnumerable$1, Stream, Type } from "igniteui-angular-core";
import { IPackagePart } from "./IPackagePart";
import { IPackage } from "./IPackage";
import { Uri } from "igniteui-angular-core";
import { IPackageRelationship } from "./IPackageRelationship";
import { RelationshipTargetMode } from "./RelationshipTargetMode";
import { WorkItem$1 } from "./WorkItem$1";
import { FileMode } from "./FileMode";
import { FileAccess } from "./FileAccess";
/**
 * @hidden
 */
export declare class CachedLoadPackagePart extends Base implements IPackagePart {
    static $t: Type;
    private readonly a;
    private readonly b;
    private c;
    constructor(a: IPackage, b: IPackagePart);
    get $package(): IPackage;
    get uri(): Uri;
    get contentType(): string;
    createRelationship(a: Uri, b: RelationshipTargetMode, c: string, d: string): IPackageRelationship;
    getRelationship(a: string): IPackageRelationship;
    getRelationships(): IEnumerable$1<IPackageRelationship>;
    getStream(a: FileMode, b: FileAccess): WorkItem$1<Stream>;
    private d;
}
