import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum DocumentSummaryPropertyType {
    Category = 2,
    PresentationTarget = 3,
    Bytes = 4,
    Lines = 5,
    Paragraphs = 6,
    Slides = 7,
    Notes = 8,
    HiddenSlides = 9,
    MMClips = 10,
    ScaleCrop = 11,
    HeadingPairs = 12,
    TitlesOfParts = 13,
    Manager = 14,
    Company = 15,
    LinksUpToData = 16,
    Status = 27
}
/**
 * @hidden
 */
export declare let DocumentSummaryPropertyType_$type: Type;
