import { IOException } from "./IOException";
import { BaseError, Type } from "igniteui-angular-core";
/**
 * Represents an error in which an attempt was made to read past the end of a stream of data.
 */
export declare class EndOfStreamException extends IOException {
    static $t: Type;
    constructor(message: string, innerException: BaseError);
}
