import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the style of the endpoint
 * of a line on a line chart.
 */
export declare enum EndStyleCap {
    /**
     * The line terminates with a cap.
     */
    Cap = 1,
    /**
     * No cap is displayed at the end of the line.
     */
    NoCap = 2
}
/**
 * @hidden
 */
export declare let EndStyleCap_$type: Type;
