import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum EscherRecordType {
    DrawingGroupContainer = 61440,
    BLIPStoreContainer = 61441,
    DrawingContainer = 61442,
    GroupContainer = 61443,
    ShapeContainer = 61444,
    SolverContainer = 61445,
    DrawingGroup = 61446,
    BLIPStoreEntry = 61447,
    Drawing = 61448,
    GroupShape = 61449,
    Shape = 61450,
    PropertyTable1 = 61451,
    Textbox = 61452,
    ClientTextbox = 61453,
    Anchor = 61454,
    ChildAnchor = 61455,
    ClientAnchor = 61456,
    ClientData = 61457,
    ConnectorRule = 61458,
    AlignRule = 61459,
    ArcRule = 61460,
    ClientRule = 61461,
    ClassID = 61462,
    CalloutRule = 61463,
    BLIPMin = 61464,
    BLIPMax = 61719,
    Regroup = 61720,
    Selections = 61721,
    ColorMRU = 61722,
    DeletedPSPL = 61725,
    SplitMenuColors = 61726,
    OLEObject = 61727,
    ColorScheme = 61728,
    PropertyTable2 = 61729,
    PropertyTable3 = 61730
}
/**
 * @hidden
 */
export declare let EscherRecordType_$type: Type;
