import { OfficeDocumentManager } from "./OfficeDocumentManager";
import { OfficeApplication } from "./OfficeApplication";
import { DrawingNamespaceDefinitionBase } from "./DrawingNamespaceDefinitionBase";
import { IPackageFactory } from "./IPackageFactory";
import { Stream, Nullable$1, Type } from "igniteui-angular-core";
import { ST_ConformanceClass } from "./ST_ConformanceClass";
/**
 * @hidden
 */
export declare abstract class ExcelDocumentManager extends OfficeDocumentManager {
    static $t: Type;
    private static readonly _bp;
    private static readonly _bo;
    private static readonly _bt;
    private static readonly _bs;
    constructor(a: IPackageFactory, b: Stream, c: boolean, d: Nullable$1<ST_ConformanceClass>);
    protected get__v(): OfficeApplication;
    get _v(): OfficeApplication;
    protected _aa(): ST_ConformanceClass;
    _bh(): void;
    protected get__t(): DrawingNamespaceDefinitionBase;
    get _t(): DrawingNamespaceDefinitionBase;
    _bq(): string;
    _br(): string;
}
