import { Type } from "igniteui-angular-core";
/**
 * Constants which define the manner in which map labels are displayed.
 */
export declare enum GeographicMapLabels {
    /**
     * Map labels are not displayed.
     */
    None = 0,
    /**
     * Map labels are displayed only for regions inside which the label can fit.
     */
    BestFit = 1,
    /**
     * Map labels are displayed for all regions.
     */
    ShowAll = 2
}
/**
 * @hidden
 */
export declare let GeographicMapLabels_$type: Type;
