import { Type } from "igniteui-angular-core";
/**
 * Constants which define the manner in which colors are used
 * to depict series values in a geographic map chart.
 */
export declare enum GeographicMapSeriesColor {
    /**
     * Two colors define the minimum and maximum series values.
     */
    Sequential = 0,
    /**
     * Three colors define the minimum, midpoint, and maximum series values.
     */
    Diverging = 1
}
/**
 * @hidden
 */
export declare let GeographicMapSeriesColor_$type: Type;
