import { ImageFormat } from "./ImageFormat";
import { BitmapSource } from "./BitmapSource";
import { IList$1, Stream, Type } from "igniteui-angular-core";
import { EncodingProperty } from "./EncodingProperty";
/**
 * @hidden
 */
export interface IImageEncoder {
    readonly imageFormat: ImageFormat;
    encode(image: BitmapSource, encodingProperties: IList$1<EncodingProperty>, stream: string | Uint8Array): void;
    _encode$i(a: BitmapSource, b: IList$1<EncodingProperty>, c: Stream): void;
}
/**
 * @hidden
 */
export declare let IImageEncoder_$type: Type;
