import { Type } from "igniteui-angular-core";
/**
 * Represents the page orientations available when a worksheet is printed.
 */
export declare enum Orientation {
    /**
     * The page is printed with the larger dimension horizontal.
     */
    Landscape = 0,
    /**
     * The page is printed with the larger dimension vertical.
     */
    Portrait = 1,
    /**
     * The page is printed with the default setting.
     */
    Default = 2
}
/**
 * @hidden
 */
export declare let Orientation_$type: Type;
