import { Base, Stream, IEnumerable$1, Type } from "igniteui-angular-core";
import { IPackagePart } from "./IPackagePart";
import { IPackage } from "./IPackage";
import { Uri } from "igniteui-angular-core";
import { WorkItem$1 } from "./WorkItem$1";
import { FileMode } from "./FileMode";
import { FileAccess } from "./FileAccess";
import { IPackageRelationship } from "./IPackageRelationship";
import { RelationshipTargetMode } from "./RelationshipTargetMode";
/**
 * @hidden
 */
export declare class OverrideContentTypePart extends Base implements IPackagePart {
    static $t: Type;
    private readonly b;
    private readonly a;
    constructor(a: IPackagePart, b: string);
    get $package(): IPackage;
    get uri(): Uri;
    get contentType(): string;
    getStream(a: FileMode, b: FileAccess): WorkItem$1<Stream>;
    createRelationship(a: Uri, b: RelationshipTargetMode, c: string, d: string): IPackageRelationship;
    getRelationships(): IEnumerable$1<IPackageRelationship>;
    getRelationship(a: string): IPackageRelationship;
}
