import { Type } from "igniteui-angular-core";
/**
 * Constants which determine the reading order.
 */
export declare enum ReadingOrder {
    /**
     * The direction is based on context.
     */
    Context = -5002,
    /**
     * The order is left-to-right.
     */
    LeftToRight = -5003,
    /**
     * The order is right-to-left.
     */
    RightToLeft = -5004
}
/**
 * @hidden
 */
export declare let ReadingOrder_$type: Type;
