import { Type } from "igniteui-angular-core";
/**
 * Represents the various sort directions which can be used with a [[SortCondition]].
 * @see [[SortCondition.sortDirection]]
 */
export declare enum SortDirection {
    /**
     * Sort values in an ascending manner.
     */
    Ascending = 0,
    /**
     * Sort values in an descending manner.
     */
    Descending = 1
}
/**
 * @hidden
 */
export declare let SortDirection_$type: Type;
