import { Type } from "igniteui-angular-core";
/**
 * Determines the type if sparkline
 * @see [[SparklineGroup.type]]
 */
export declare enum SparklineType {
    /**
     * A line sparkline
     */
    Line = 0,
    /**
     * A series of vertical columns
     */
    Column = 1,
    /**
     * Deprecated - same as WinLoss
     */
    Stacked = 2,
    /**
     * Positive and negative values stacked
     */
    WinLoss = 2
}
/**
 * @hidden
 */
export declare let SparklineType_$type: Type;
