import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum ValueFormatter_WellKnownPartType {
    Whitespace = 0,
    GeneralString = 1,
    VerbatimString = 2,
    DecimalSeparator = 3,
    DigitOrEmpty = 4,
    DigitOrZero = 5,
    DigitOrWhitespace = 6,
    GroupShiftPlaceholder = 7,
    Percent = 8,
    FractionSeparator = 9,
    Scientific = 10,
    ScientificWithSign = 11,
    AMPMShortLL = 12,
    AMPMShortLU = 13,
    AMPMShortUL = 14,
    AMPMShortUU = 15,
    AMPMLong = 16,
    AMPMChinese = 17,
    HoursShort = 18,
    HoursLong = 19,
    HoursTotal = 20,
    Milliseconds1 = 21,
    Milliseconds2 = 22,
    Milliseconds3 = 23,
    MinutesShort = 24,
    MinutesLong = 25,
    MinutesTotal = 26,
    SecondsShort = 27,
    SecondsLong = 28,
    SecondsTotal = 29,
    BuddhistYearsShort = 30,
    BuddhistYearsLong = 31,
    DaysShort = 32,
    DaysLong = 33,
    DayShortDescription = 34,
    DayLongDescription = 35,
    MonthsShort = 36,
    MonthsLong = 37,
    MonthShortDescription = 38,
    MonthLongDescription = 39,
    MonthFirstLetter = 40,
    YearsShort = 41,
    YearsLong = 42,
    EraYearsShort = 43,
    EraYearsLong = 44,
    EraEnglishName = 45,
    EraAbbreviatedName = 46,
    EraName = 47,
    DayShortDescriptionLocalized = 48,
    DayLongDescriptionLocalized = 49
}
/**
 * @hidden
 */
export declare let ValueFormatter_WellKnownPartType_$type: Type;
