import { Type } from "igniteui-angular-core";
/**
 * Represents the various vertical text alignment types.
 */
export declare enum VerticalTextAlignment {
    /**
     * Align the text to the bottom of the available area.
     */
    Bottom = 0,
    /**
     * Align the center to the bottom of the available area.
     */
    Center = 1,
    /**
     * Align the text to the top of the available area.
     */
    Top = 2
}
/**
 * @hidden
 */
export declare let VerticalTextAlignment_$type: Type;
