import { Base, Type } from "igniteui-angular-core";
import { IWorkbookOwner } from "./IWorkbookOwner";
import { WorksheetRow } from "./WorksheetRow";
import { IChangeInfoContext } from "./IChangeInfoContext";
import { ChangeInfo$2 } from "./ChangeInfo$2";
import { WorksheetRegion } from "./WorksheetRegion";
import { CustomView } from "./CustomView";
import { Sheet } from "./Sheet";
import { ExcelChangeAction } from "./ExcelChangeAction";
/**
 * @hidden
 */
export declare class WeakWorkbookOwner extends Base implements IWorkbookOwner {
    static $t: Type;
    private readonly b;
    constructor(a: IWorkbookOwner);
    get a(): IWorkbookOwner;
    get isUndoEnabled(): boolean;
    onCellValueChange(a: WorksheetRow, b: number): void;
    _onChange$2$i<TContext extends IChangeInfoContext, TValue>($tContext: Type, $tValue: Type, a: TContext, b: boolean, c: TValue, d: TValue, e: ChangeInfo$2<TContext, TValue>): void;
    onConditionalFormatChange(a: WorksheetRegion): void;
    onCustomViewApplied(a: CustomView): void;
    onSheetRemoving(a: Sheet): void;
    onTransactionalChangeBegin(a: ExcelChangeAction, b: string): any;
    onTransactionalChangeEnd(a: any): void;
    onTransactionalChangeRollback(a: any): void;
}
