import { Base, Type } from "igniteui-angular-core";
import { IEG_AnchorVisitor$2 } from "./IEG_AnchorVisitor$2";
import { Tuple$2 } from "igniteui-angular-core";
import { Sheet } from "./Sheet";
import { WorksheetShape } from "./WorksheetShape";
import { CT_AbsoluteAnchor } from "./CT_AbsoluteAnchor";
import { CT_OneCellAnchor } from "./CT_OneCellAnchor";
import { CT_TwoCellAnchor } from "./CT_TwoCellAnchor";
/**
 * @hidden
 */
export declare class WorkbookLoadManagerExcel2007_ShapeAnchorApplicator extends Base implements IEG_AnchorVisitor$2<Tuple$2<Sheet, WorksheetShape>, boolean> {
    static $t: Type;
    static readonly a: WorkbookLoadManagerExcel2007_ShapeAnchorApplicator;
    _visitCT_AbsoluteAnchor$i(a: CT_AbsoluteAnchor, b: Tuple$2<Sheet, WorksheetShape>): boolean;
    _visitCT_OneCellAnchor$i(a: CT_OneCellAnchor, b: Tuple$2<Sheet, WorksheetShape>): boolean;
    _visitCT_TwoCellAnchor$i(a: CT_TwoCellAnchor, b: Tuple$2<Sheet, WorksheetShape>): boolean;
}
