import { FormulaTokenVisitor$1 } from "./FormulaTokenVisitor$1";
import { FormulaToken } from "./FormulaToken";
import { BiffRecordStream } from "./BiffRecordStream";
import { Area3DToken } from "./Area3DToken";
import { AreaErrToken } from "./AreaErrToken";
import { AreaToken } from "./AreaToken";
import { ArrayToken } from "./ArrayToken";
import { AttrChooseToken } from "./AttrChooseToken";
import { AttrIfToken } from "./AttrIfToken";
import { AttrSkipToken } from "./AttrSkipToken";
import { AttrSpaceToken } from "./AttrSpaceToken";
import { AttrSumToken } from "./AttrSumToken";
import { AttrVolatileToken } from "./AttrVolatileToken";
import { BinaryOperatorToken } from "./BinaryOperatorToken";
import { BoolToken } from "./BoolToken";
import { ErrToken } from "./ErrToken";
import { ExpToken } from "./ExpToken";
import { FunctionOperator } from "./FunctionOperator";
import { FunctionVOperator } from "./FunctionVOperator";
import { IntToken } from "./IntToken";
import { MemAreaOperator } from "./MemAreaOperator";
import { MemErrOperator } from "./MemErrOperator";
import { MemFuncOperator } from "./MemFuncOperator";
import { MemNoMemOperator } from "./MemNoMemOperator";
import { MissArgToken } from "./MissArgToken";
import { NameToken } from "./NameToken";
import { NameXToken } from "./NameXToken";
import { NumberToken } from "./NumberToken";
import { ParenToken } from "./ParenToken";
import { Ref3DToken } from "./Ref3DToken";
import { RefErrToken } from "./RefErrToken";
import { RefToken } from "./RefToken";
import { StrToken } from "./StrToken";
import { StructuredTableReference } from "./StructuredTableReference";
import { TblToken } from "./TblToken";
import { UnaryOperatorToken } from "./UnaryOperatorToken";
import { FormulaContext } from "./FormulaContext";
import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare class WorkbookSaveManagerExcel2003_GetSizeTokenVisitor extends FormulaTokenVisitor$1<number> {
    static $t: Type;
    private static a4;
    private a6;
    private a3;
    private a2;
    constructor();
    d(a: FormulaToken): number;
    a1(): void;
    f(a: Area3DToken): number;
    h(a: AreaErrToken): number;
    j(a: AreaToken): number;
    k(a: ArrayToken): number;
    l(a: AttrChooseToken): number;
    m(a: AttrIfToken): number;
    n(a: AttrSkipToken): number;
    o(a: AttrSpaceToken): number;
    p(a: AttrSumToken): number;
    q(a: AttrVolatileToken): number;
    r(a: BinaryOperatorToken): number;
    s(a: BoolToken): number;
    u(a: ErrToken): number;
    v(a: ExpToken): number;
    w(a: FunctionOperator): number;
    y(a: FunctionVOperator): number;
    z(a: IntToken): number;
    aa(a: MemAreaOperator): number;
    ab(a: MemErrOperator): number;
    ac(a: MemFuncOperator): number;
    ad(a: MemNoMemOperator): number;
    ae(a: MissArgToken): number;
    af(a: NameToken): number;
    ag(a: NameXToken): number;
    ah(a: NumberToken): number;
    aj(a: ParenToken): number;
    al(a: Ref3DToken): number;
    ao(a: RefErrToken): number;
    aq(a: RefToken): number;
    ar(a: StrToken): number;
    as(a: StructuredTableReference): number;
    at(a: TblToken): number;
    au(a: UnaryOperatorToken): number;
    static a5(a: FormulaContext, b: BiffRecordStream, c: boolean, d: number[]): WorkbookSaveManagerExcel2003_GetSizeTokenVisitor;
    static a7(a: AttrChooseToken): number;
}
