import { Type } from "igniteui-angular-core";
/**
 * Determines whether worksheet rows of columns are sorted within the region
 * @see [[WorksheetSortSettings]]
 * @see [[Worksheet.sortSettings]]
 */
export declare enum WorksheetSortType {
    /**
     * Sort rows
     */
    Rows = 0,
    /**
     * Sort columns
     */
    Columns = 1
}
/**
 * @hidden
 */
export declare let WorksheetSortType_$type: Type;
