import { Type } from "igniteui-angular-core";
/**
 * @hidden
 */
export declare const enum XFPropType {
    PatternFill = 0,
    ForegroundColor = 1,
    BackgroundColor = 2,
    GradientFill = 3,
    GradientStop = 4,
    FontColor = 5,
    TopBorder = 6,
    BottomBorder = 7,
    LeftBorder = 8,
    RightBorder = 9,
    DiagonalBorder = 10,
    VerticalBorder = 11,
    HorizontalBorder = 12,
    DiagonalUpBorder = 13,
    DiagonalDownBorder = 14,
    HorizontalAlignment = 15,
    VerticalAlignment = 16,
    TextRotation = 17,
    TextIndentationLevel = 18,
    ReadingOrder = 19,
    WrappedText = 20,
    JustifyDistributed = 21,
    ShrinkToFit = 22,
    CellMerged = 23,
    FontName = 24,
    FontBold = 25,
    FontUnderline = 26,
    FontSubscriptSuperscript = 27,
    FontItalic = 28,
    FontStrikethrough = 29,
    FontOutline = 30,
    FontShadow = 31,
    FontCondensed = 32,
    FontExtended = 33,
    FontCharacterSet = 34,
    FontFamily = 35,
    FontHeight = 36,
    FontScheme = 37,
    NumberFormat = 38,
    NumberFormatId = 41,
    TextIndentationLevelRelative = 42,
    Locked = 43,
    Hidden = 44
}
/**
 * @hidden
 */
export declare let XFPropType_$type: Type;
